; Copyright    Barbara Liskov    1983, 1985, 1986

record = selector is get_, set_, r_gets_r, r_gets_s, equal, similar, similar1,
		     copy, copy1, print, mget, mput

transmit any where seltype has transmit

get_ = qselproc (rec: cvt) returns (seltype)
	movl	select,n1
	movl	(rr)[n1],rr
	return(rr)
	end get_

set_ = qselproc (rec: cvt, elt: seltype)
	movl	select,n1
	movl	rr,@rec[n1]
	end set_

r_gets_r = qproc (rec1, rec2: cvt)
	movl	rec1,r1
	ashl	2,(rr),n1		; get byte count
	movc	n1,4(rr),4(r1)		; copy
	end r_gets_r

r_gets_s = qproc (rec: cvt, str: struct[])
	movl	rec,r1
	ashl	2,(rr),n1		; get byte count
	movc	n1,4(rr),4(r1)		; copy
	end r_gets_s

equal = qproc (rec1, rec2: cvt) returns (bool)
	ifeql	cmpl	rec1,rr
	then	return(true)
	end
	return(false)
	end equal

similar = proc (rec1, rec2: cvt) returns (bool) signals (failure(string))
	  where seltype has similar: proctype (seltype, seltype) returns (bool)
								 signals (failure(string))
	var	idx
	movl	1,idx
	qloop
		movl	idx,n1
		pushl	@rec1[n1]
		movl	@rec2[n1],rr
		movl	@selops[similar][n1],r1	; get similar op
		r1(*, rr){failure}		; compare
		   resignal failure
		blbc	rr,next
		aobleq	@rec1,idx,this		; bump index
	end
	return(rr)
	end similar

similar1 = proc (rec1, rec2: cvt) returns (bool) signals (failure(string))
	  where seltype has equal: proctype (seltype, seltype) returns (bool)
							       signals (failure(string))
	var	idx
	movl	1,idx
	qloop
		movl	idx,n1
		pushl	@rec1[n1]
		movl	@rec2[n1],rr
		movl	@selops[equal][n1],r1	; get equal op
		r1(*, rr){failure}		; compare
		   resignal failure
		blbc	rr,next
		aobleq	@rec1,idx,this		; bump index
	end
	return(rr)
	end similar1

copy = proc (rec: cvt) returns (cvt) signals (failure(string))
	  where seltype has copy: proctype (seltype) returns (seltype)
						     signals (failure(string))
	var	idx
	valloc	(rr),r1				; alloc
	movc	n0,(rr),(r1)			; copy
	movl	r1,rec
	movl	1,n1
	qloop
		movl	n1,idx			; store index
		movl	(r1)[n1],rr
		movl	@selops[copy][n1],r1	; get copy op
		r1(rr){failure}			; copy
		   resignal failure
		movl	rec,r1
		movl	idx,n1
		movl	rr,(r1)[n1]		; set component
		aobleq	(r1),n1,this		; bump index
	end
	return(r1)
	end copy

copy1 = qproc (rec: cvt) returns (cvt)
	valloc	(rr),r1				; alloc
	movc	n0,(rr),(r1)			; copy
	return(r1)
	end copy1

print = proc (rec: cvt, ps: pstream) signals (failure(string))
	    where seltype has print: proctype (seltype, pstream)
						signals (failure(string))
	var	idx, max
	ift	pstream$start(rr, "{")
	then	movl	rec,rr
		clrl	n2
		iff	pstream$get_flat(ps)
		then	movl	1,n1
			qloop
				movl	@selnames[n1],rr
				ifgtru	cmpw	(rr),n2
				then	movzwl	(rr),n2
				end
				aobleq	@selnames,n1,this
			end
		end
		movl	n2,max
		movl	1,idx
		br	getidx
		qloop
			pstream$next(ps, ",")		; no, print comma
			blbc	rr,next			; stop if ...
getidx:			movl	idx,n1
			movl	@selnames[n1],rr	; get name
			pstream$puts(ps, rr)		; print it
			pstream$puts(ps, ": ")
			ifgtr	movl	idx,n1
				movl	@selnames[n1],rr
				movzwl	(rr),rr
				subl	rr,max,rr
			then	pstream$putspace(ps, rr)
				movl	idx,n1
			end
			pushl	@rec[n1]		; get component
			movl	@selops[print][n1],r1	; get print op
			r1(*, ps){failure}		; print
			   resignal failure
			aobleq	@selnames,idx,this	; bump index
		end
	end
	pstream$stop(ps, "}")
	end print

mput = proc(m:out_msg, rec:cvt) returns (out_msg)
		where seltype has mput: proctype(seltype, out_msg)
	var 	idx
	movl 	1,idx				; init index to 1st field
	qloop
		movl	idx,n1			; restore index to register
		pushl	@rec[n1]		; fetch field
		movl	@selops[mput][n1],r1 	; fetch mput for that field's type
		r1(*,m)				; invoke the mput
		aobleq	@rec,idx,this		; advance to next field
	end
	return(rr)
end mput

mget = proc(m:in_msg) returns (cvt)
		where seltype has mget: proctype(in_msg) returns (seltype)
	var idx
	movl	@selops[%get],n1		; get size/header of record
	valloc	n1,(r3)				; allocate record
	movl	1,idx				; initialize index
	qloop
		movl	idx,n1			; restore index to reg
		movl	@selops[mget][n1],r1	; fetch mget for this field/type
		r1(m)				; invoke the mget
		movl	idx,n1			; restore index to register
		movl	rr,(r3)[n1]		; save the value for this field
		aobleq	(r3),idx,this		; advance to next field
	end
	return(r3)
end mget

%put = proc (rec: cvt) signals (failure(string), error(int))
	pushl	selops[%put]
	_encode$putr(*, rr){failure, error}
	   resignal failure, error
	end %put

%get = proc () returns (cvt) signals (failure(string))
	movl	selops[%get],rr
	_decode$getr(rr){failure}
	   resignal failure
	return(rr)
	end %get

end record
