@part[Appendix1,root "thesis.mss"]

@appendix[Blue Language Grammar]

This appendix contains the grammar of the blue language @cite[cveneer].

@begin[verbatim]
<mercury-typedef> :== (defmtype <type-name> <mtype-spec>) |
		      (defabstype <type-name> <param-spec>
					    <abstype-spec>)
			  

<type-spec> :== <type-name> |
		<scalar-spec> |
		<fixed-sequence-spec> |
		<sequence-spec> |
		<struct-spec> |
		<oneof-spec> |
		<union-spec> |
		<image-spec> |
		<undefined-spec> |
		<port-spec> |
		<param-name>@footnote[Only for abstract specifications]

<param-spec> :== [<param-name>...]

<scalar-spec> :== NULL |
		  CHAR |
		  INT16 |
		  INT32 |
		  BYTE |
		  CARD16 |
		  CARD32 |
		  REAL32 |
		  REAL64 |
		  BOOL |
		  STRING
			   
<fixed-sequence-spec> :== (FIXED-SEQUENCE <mtype-spec>
					      <length>)

<sequence-spec> :== (SEQUENCE <mtype-spec>)

<struct-spec> :== (STRUCT <field-definition>)

<oneof-spec> :== (ONEOF <field-definition>)

<union-spec> :== (UNION <field-definition>)

<image-spec> :== IMAGE

<undefined-spec> :== POINTER, CONTAINER specification@footnote[These types are
not defined in the current Mercury implementation]

<port-spec> :== (PORT ([<input-argument>...])
		      ([<return-argument>...])
		      ([<exception>...]))



<input-argument> :== <field-definition>

<return-argument> :== <field-definition>

<exception> :== (<exception-name>
		 [([<field-definition>...])])

<field-definition> :== (<field-name> <mtype-spec>)


<type-name>, <param-name>, <exception-name>, and 
			    <field-name> :== character string

@end[verbatim]
