@Part(preface, Root "manual.mss")
@begin(TitlePage)
@begin(TitleBox)
Massachusetts Institute of Technology, Cambridge, Massachusetts
Laboratory for Computer Science





@Huge[Argus@ @ Reference@ @ Manual]
@end(TitleBox)
@begin(center)
Barbara Liskov
Mark Day
Maurice Herlihy
Paul Johnson
Gary Leavens (editor)
Robert Scheifler
William Weihl
@end(center)
@BlankSpace(2 lines)
@begin(center)
@Value(date)
@end(center)
@begin(ResearchCredit)
This work has been generously
supported
in part by the Advanced Research Projects Agency
of the Department of Defense, monitored by the Office
of Naval Research under contract N00014-83-K-0125,
and
in part by the
National Science Foundation under grant DCR-8503662.
@end(ResearchCredit)
@end(TitlePage)

@PrefaceSection(Guide to the Manual)

This document serves both as a reference manual and
as an introduction to Argus.
Sections 1 through 3 present an overview of the language.
These sections highlight the essential features of Argus.
Sections 4 through 15 and the appendices form the reference manual proper.
These sections
describe each aspect of Argus in detail, and discuss the proper use of
various features.  Appendices I and II provide summaries of
Argus's syntax and data types.
Appendix III summarizes some of the pragmatic rules for using Argus.
@comment{Appendix IV contains example programs.}

Since Argus is based on the programming language CLU,
the reader is expected to have some familiarity with CLU.
Those readers needing an introduction to CLU might read
Liskov, B. and Guttag, J.,
@i(Abstraction and Specification in Program Development)
(MIT Press, Cambridge, 1986).
A shorter overview of CLU appears in the article
Liskov, B., @i(et al.),
"Abstraction Mechanisms in CLU"
(@i(Comm. ACM), volume 20, number 8 (Aug. 1977), pages 564-576).
Appendix @ref(apdx-diffs) summarizes the changes made to Argus that
are not upward compatible with CLU.

An overview and rationale for Argus is presented in
Liskov, B. and Scheifler, R.,
"Guardians and Actions: Linguistic Support for Robust, Distributed Programs"
(@i(ACM Transactions on Programming Languages and Systems),
volume 5, number 3 (July 1983), pages 381-404).

The @i(Preliminary Argus Reference Manual)
appeared as Programming Methodology Group Memo 39 in October 1983.
Since that time several new features have been added to the language;
the most significant of these are
closures (see Section @ref(sect-bind)),
a @b[fork] statement (see Section @ref(sect-fork)),
equate modules (see Section @ref(sect-equate-module)),
and a more flexible instantiation mechanism
(see Section @ref(sect-instantiations)).
An earlier version of this document
appeared as Programming Methodology Group Memo 54 in March 1987;
this version is essentially identical,
except that the locking policy for
the built-in type generator @b[atomic@us<>array]
has been simplified.

We would greatly appreciate receiving comments on both the language
and this manual.
Comments should be sent to:
Professor Barbara Liskov,
Laboratory for Computer Science,
Massachusetts Institute of Technology,
545 Technology Square,
Cambridge, MA 02139.

The authors thank all the members of the Programming Methodology group at MIT
for their help and
suggestions regarding the language and this manual,
with special thanks going to
Elliot Kolodner,
Deborah Hwang,
Sharon Perl,
and the authors of the @i(CLU Reference Manual).

@NewPage()

@BlankSpace(10 lines)

@begin(Verse, LeftMargin +1.4 inches)
Though her unhappy rival was hers to keep
Queen Juno also had a troubled mind:
What would Jove turn to next?  Better, she thought,
To give the creature to Arestor's son,
The frightful Argus whose unnatural head
Shone with a hundred eyes, a perfect jailer
For man or beast:  the hundred eyes took turns
At staring wide awake in pairs, and two
At falling off to sleep; no matter how or
Where he stood he gazed at Io;  even when
His back was turned, he held his prisoner
In sight and in his care.
@end(Verse)
@begin(FlushRight)
@Dash() Ovid, @i(The Metamorphoses), Book 1
	           Translated by H. Gregory
     The Viking Press, Inc., New York, 1958
@end(FlushRight)
