@Part(Syntax, Root "manual.mss")
@Make[Manual]

@Textform{mult="*"}

@Appendix(Syntax)
@Label(apdx-syntax)
@Define(AppHeading=Subheading,Centered,Above 2)
We use an extended BNF grammar to define the syntax.
@index(syntax)@index(BNF)
The general form of a production is
@begin(SyntaxDisplay)
@tabclear
@tabset(1.1inches, 1.5inches, 2inches, 2.8inches, 4inches)
nonterminal@\@BNFequals()@\alternative 
@\   @BNFor()@\alternative 
@\   @BNFor()@\@BNFdots() 
@\   @BNFor()@\alternative
@end(SyntaxDisplay)

The following extensions are used:
@begin(description)
a , @BNFdots()@\a list of one or more @i(a)s separated by commas:  "a" or "a, a" or "a, a, a", etc.

@BNFlcurly() a @BNFrcurly()@\a sequence of zero or more @i(a)s:  " " or "a" or "a a", etc.

@BNFlbkt() a @BNFrbkt()@\an optional @i(a):  " " or "a".
@end(description)

Nonterminal symbols appear in normal face.
Reserved words appear in @b[bold] face.
All other terminal symbols are nonalphabetic
and appear in normal face.

@Blankspace(3 lines)

@begin(SyntaxDisplay, LeftMargin 0, RightMargin 0)
@tabclear
@tabset(1.1inches, 1.5inches, 2inches, 2.8inches, 4inches)
module@\@BNFequals()@\@BNFlcurly() equate @BNFrcurly() equates
@\   @BNFor()@\@BNFlcurly() equate @BNFrcurly() guardian
@\   @BNFor()@\@BNFlcurly() equate @BNFrcurly() procedure
@\   @BNFor()@\@BNFlcurly() equate @BNFrcurly() iterator
@\   @BNFor()@\@BNFlcurly() equate @BNFrcurly() cluster


equates@\@BNFequals()@\idn = @b(equates) @BNFlbkt() parms @BNFlbkt() where @BNFrbkt() @BNFrbkt()
@\@\@\equate @BNFlcurly() equate @BNFrcurly()
@\@\@\@b(end) idn


guardian@\@BNFequals()@\idn = @b(guardian) @BNFlbkt() parms @BNFrbkt() @b(is) idn , @BNFdots() @BNFlbkt() @b(handles) idn , @BNFdots()@BNFrbkt() @BNFlbkt() where @BNFrbkt()
@\@\@\@BNFlcurly() equate @BNFrcurly()
@\@\@\@BNFlcurly() state@us()decl @BNFrcurly()
@\@\@\@BNFlbkt() @b(recover) body @b(end) @BNFrbkt()
@\@\@\@BNFlbkt() @b(background) body @b(end) @BNFrbkt()
@\@\@\@BNFlcurly() operation @BNFrcurly() creator @BNFlcurly() operation @BNFrcurly()
@\@\@\@b(end) idn

cluster@\@BNFequals()@\idn = @b(cluster) @BNFlbkt() parms @BNFrbkt() @b(is) opidn , @BNFdots() @BNFlbkt() where @BNFrbkt()
@\@\@\@BNFlcurly() equate @BNFrcurly() @b(rep) = type@us()spec @BNFlcurly() equate @BNFrcurly()
@\@\@\@BNFlcurly() own@us()var @BNFrcurly()
@\@\@\routine @BNFlcurly() routine @BNFrcurly()
@\@\@\@b(end) idn

@NewPage()

operation@\@BNFequals()@\creator
@\   @BNFor()@\handler
@\   @BNFor()@\routine

routine@\@BNFequals()@\procedure
@\   @BNFor()@\iterator

procedure@\@BNFequals()@\idn = @b(proc) @BNFlbkt() parms @BNFrbkt() args @BNFlbkt() returns @BNFrbkt() @BNFlbkt() signals @BNFrbkt() @BNFlbkt() where @BNFrbkt() 
@\@\@\routine@us()body
@\@\@\@b(end) idn

iterator@\@BNFequals()@\idn = @b(iter) @BNFlbkt() parms @BNFrbkt() args @BNFlbkt() yields @BNFrbkt() @BNFlbkt() signals @BNFrbkt() @BNFlbkt() where @BNFrbkt()
@\@\@\routine@us()body
@\@\@\@b(end) idn

creator@\@BNFequals()@\idn = @b(creator) args @BNFlbkt() returns @BNFrbkt() @BNFlbkt() signals @BNFrbkt() 
@\@\@\routine@us()body
@\@\@\@b(end) idn

handler@\@BNFequals()@\idn = @b(handler) args @BNFlbkt() returns @BNFrbkt() @BNFlbkt() signals @BNFrbkt() 
@\@\@\routine@us()body
@\@\@\@b(end) idn

routine@us()body@\@BNFequals()@\@BNFlcurly() equate @BNFrcurly()
@\@\@BNFlcurly() own@us()var @BNFrcurly()
@\@\@BNFlcurly() statement @BNFrcurly()


parms@\@BNFequals()@\[ parm , @BNFdots() ]

parm@\@BNFequals()@\idn , @BNFdots() : @b(type) 
@\   @BNFor()@\idn , @BNFdots() : type@us()spec


args@\@BNFequals()@\( @BNFlbkt() decl , @BNFdots() @BNFrbkt() )

decl@\@BNFequals()@\idn , @BNFdots() : type@us()spec

returns@\@BNFequals()@\@b(returns) ( type@us()spec , @BNFdots() )

yields@\@BNFequals()@\@b(yields) ( type@us()spec , @BNFdots() )

signals@\@BNFequals()@\@b(signals) ( exception , @BNFdots() )

exception@\@BNFequals()@\name @BNFlbkt() ( type@us()spec , @BNFdots() ) @BNFrbkt()

@NewPage()

opidn@\@BNFequals()@\idn
@\   @BNFor()@\@b(transmit)


where@\@BNFequals()@\@b(where) restriction , @BNFdots()

restriction@\@BNFequals()@\idn @b(has) oper@us()decl , @BNFdots()
@\   @BNFor()@\idn @b(in) type@us()set

type@us()set@\@BNFequals()@\{ idn | idn @b(has) oper@us()decl , @BNFdots() @BNFlcurly() equate @BNFrcurly() } 
@\   @BNFor()@\idn
@\   @BNFor()@\reference $ name

oper@us()decl@\@BNFequals()@\name , @BNFdots() : type@us()spec
@\   @BNFor()@\@b(transmit)


constant@\@BNFequals()@\expression 
@\   @BNFor()@\type@us()spec


state@us()decl@\@BNFequals()@\@BNFlbkt() @b(stable) @BNFrbkt() decl
@\   @BNFor()@\@BNFlbkt() @b(stable) @BNFrbkt() idn : type@us()spec := expression
@\   @BNFor()@\@BNFlbkt() @b(stable) @BNFrbkt() decl , @BNFdots() := call


equate@\@BNFequals()@\idn = constant 
@\   @BNFor()@\idn = type@us()set
@\   @BNFor()@\idn = reference


own@us()var@\@BNFequals()@\@b(own) decl
@\   @BNFor()@\@b(own) idn : type@us()spec := expression
@\   @BNFor()@\@b(own) decl , @BNFdots() := call @BNFlbkt() @@ primary @BNFrbkt()

@NewPage()

statement@\@BNFequals()@\decl
@\   @BNFor()@\idn : type@us()spec := expression
@\   @BNFor()@\decl , @BNFdots() := call @BNFlbkt() @@ primary @BNFrbkt()
@\   @BNFor()@\idn , @BNFdots() := call @BNFlbkt() @@ primary @BNFrbkt()
@\   @BNFor()@\idn , @BNFdots() := expression , @BNFdots()
@\   @BNFor()@\primary @big(.) name := expression
@\   @BNFor()@\primary [ expression ] := expression
@\   @BNFor()@\call @BNFlbkt() @@ primary @BNFrbkt()
@\   @BNFor()@\@b(fork) call
@\   @BNFor()@\@b(seize) expression @b(do) body @b(end)
@\   @BNFor()@\@b(pause)
@\   @BNFor()@\@b(terminate)
@\   @BNFor()@\enter@us()stmt
@\   @BNFor()@\@b(coenter) coarm @BNFlcurly() coarm @BNFrcurly() @b(end)
@\   @BNFor()@\@BNFlbkt() @b(abort) @BNFrbkt() @b(leave)
@\   @BNFor()@\@b(while) expression @b(do) body @b(end)
@\   @BNFor()@\for@us()stmt
@\   @BNFor()@\if@us()stmt
@\   @BNFor()@\tagcase@us()stmt
@\   @BNFor()@\tagtest@us()stmt
@\   @BNFor()@\tagwait@us()stmt
@\   @BNFor()@\@BNFlbkt() @b(abort) @BNFrbkt() @b(return) @BNFlbkt() ( expression , @BNFdots() ) @BNFrbkt()
@\   @BNFor()@\@b(yield) @BNFlbkt() ( expression , @BNFdots() ) @BNFrbkt()
@\   @BNFor()@\@BNFlbkt() @b(abort) @BNFrbkt() @b(signal) name @BNFlbkt() ( expression , @BNFdots() ) @BNFrbkt()
@\   @BNFor()@\@BNFlbkt() @b(abort) @BNFrbkt() @b(exit) name @BNFlbkt() ( expression , @BNFdots() ) @BNFrbkt()
@\   @BNFor()@\@BNFlbkt() @b(abort) @BNFrbkt() @b(break)
@\   @BNFor()@\@BNFlbkt() @b(abort) @BNFrbkt() @b(continue)
@\   @BNFor()@\@b(begin) body @b(end)
@\   @BNFor()@\statement @BNFlbkt() @b(abort) @BNFrbkt() @b(resignal) name , @BNFdots()
@\   @BNFor()@\statement @b(except)@\@BNFlcurly() when@us()handler @BNFrcurly()
@\@\@\@\@BNFlbkt() others@us()handler @BNFrbkt()
@\@\@\@\@b(end)

enter@us()stmt@\@BNFequals()@\@b(enter) @b(topaction) body @b(end)
@\   @BNFor()@\@b(enter) @b(action) body @b(end)

@NewPage()

coarm@\@BNFequals()@\armtag @BNFlbkt() @b(foreach) decl , @BNFdots() @b(in) call @BNFrbkt() body

armtag@\@BNFequals()@\@b(action)
@\   @BNFor()@\@b(topaction)
@\   @BNFor()@\@b(process)

for@us()stmt@\@BNFequals()@\@b(for) @BNFlbkt() decl , @BNFdots() @BNFrbkt() @b(in) call @b(do) body @b(end)
@\   @BNFor()@\@b(for) @BNFlbkt() idn , @BNFdots() @BNFrbkt() @b(in) call @b(do) body @b(end)

if@us()stmt@\@BNFequals()@\@b(if) expression @b(then) body
@\   @\@\@BNFlcurly() @b(elseif) expression @b(then) body @BNFrcurly()
@\   @\@\@BNFlbkt() @b(else) body @BNFrbkt()
@\   @\@\@b(end)

tagcase@us()stmt@\@BNFequals()@\@b(tagcase) expression
@\   @\@\tag@us()arm @BNFlcurly() tag@us()arm @BNFrcurly()
@\   @\@\@BNFlbkt() @b(others) : body @BNFrbkt()
@\   @\@\@b(end)

tagtest@us()stmt@\@BNFequals()@\@b(tagtest) expression
@\   @\@\atag@us()arm @BNFlcurly() atag@us()arm @BNFrcurly()
@\   @\@\@BNFlbkt() @b(others) : body @BNFrbkt()
@\   @\@\@b(end)

tagwait@us()stmt@\@BNFequals()@\@b(tagwait) expression
@\   @\@\atag@us()arm @BNFlcurly() atag@us()arm @BNFrcurly()
@\   @\@\@b(end)

tag@us()arm@\@BNFequals()@\@b(tag) name , @BNFdots() @BNFlbkt() ( idn : type@us()spec ) @BNFrbkt() : body

atag@us()arm@\@BNFequals()@\tag@us()kind name , @BNFdots() @BNFlbkt() ( idn : type@us()spec ) @BNFrbkt() : body

tag@us()kind@\@BNFequals()@\@b(tag)
@\   @BNFor()@\@b(wtag)

when@us()handler@\@BNFequals()@\@b(when) name , @BNFdots() @BNFlbkt() ( decl , @BNFdots() )@BNFrbkt() : body
@\   @BNFor()@\@b(when) name , @BNFdots() ( @mult() ) : body

others@us()handler@\@BNFequals()@\@b(others) @BNFlbkt() ( idn : type@us()spec ) @BNFrbkt() : body

body@\@BNFequals()@\@BNFlcurly() equate @BNFrcurly()
@\@\@BNFlcurly() statement @BNFrcurly()

@NewPage()

type@us()spec@\@BNFequals() @b(null)
@\   @BNFor()@\@b(node)
@\   @BNFor()@\@b(bool)
@\   @BNFor()@\@b(int)
@\   @BNFor()@\@b(real)
@\   @BNFor()@\@b(char)
@\   @BNFor()@\@b(string)
@\   @BNFor()@\@b(any)
@\   @BNFor()@\@b(image)
@\   @BNFor()@\@b(rep) 
@\   @BNFor()@\@b(cvt)
@\   @BNFor()@\@b(sequence) [ type@us()actual ]
@\   @BNFor()@\@b(array) [ type@us()actual ] 
@\   @BNFor()@\@b(atomic@us()array) [ type@us()actual ] 
@\   @BNFor()@\@b(struct) [ field@us()spec , @BNFdots() ]
@\   @BNFor()@\@b(record) [ field@us()spec , @BNFdots() ] 
@\   @BNFor()@\@b(atomic@us()record) [ field@us()spec , @BNFdots() ] 
@\   @BNFor()@\@b(oneof) [ field@us()spec , @BNFdots() ] 
@\   @BNFor()@\@b(variant) [ field@us()spec , @BNFdots() ]
@\   @BNFor()@\@b(atomic@us()variant) [ field@us()spec , @BNFdots() ]
@\   @BNFor()@\@b(proctype) ( @BNFlbkt() type@us()spec , @BNFdots() @BNFrbkt() ) @BNFlbkt() returns @BNFrbkt() @BNFlbkt() signals @BNFrbkt()
@\   @BNFor()@\@b(itertype) ( @BNFlbkt() type@us()spec , @BNFdots() @BNFrbkt() ) @BNFlbkt() yields @BNFrbkt() @BNFlbkt() signals @BNFrbkt()
@\   @BNFor()@\@b(creatortype) ( @BNFlbkt() type@us()spec , @BNFdots() @BNFrbkt() ) @BNFlbkt() returns @BNFrbkt() @BNFlbkt() signals @BNFrbkt()
@\   @BNFor()@\@b(handlertype) ( @BNFlbkt() type@us()spec , @BNFdots() @BNFrbkt() ) @BNFlbkt() returns @BNFrbkt() @BNFlbkt() signals @BNFrbkt()
@\   @BNFor()@\@b(mutex) [ type@us()actual ]
@\   @BNFor()@\reference

field@us()spec@\@BNFequals()@\name , @BNFdots() : type@us()actual

reference@\@BNFequals()@\idn
@\	@BNFor()@\idn [ actual@us<>parm , @BNFdots() ]
@\	@BNFor()@\reference $ name

actual@us<>parm@\@BNFequals()@\constant
@\	@BNFor()@\type@us<>actual

type@us<>actual@\@BNFequals()@\type@us()spec @BNFlbkt() @b[with] { opbinding , @BNFdots() } @BNFrbkt()

opbinding@\@BNFequals() name , @BNFdots() : primary

@NewPage()

expression@\@BNFequals()@\primary
@\   @BNFor()@\call @@ primary
@\   @BNFor()@\( expression )
@\   @BNFor()@\~ expression@\@\% 6    (precedence)
@\   @BNFor()@\@MinusSign() expression@\@\% 6
@\   @BNFor()@\expression @mult()@mult() expression@\%     5
@\   @BNFor()@\expression // expression@\%          4
@\   @BNFor()@\expression / expression@\%          4
@\   @BNFor()@\expression @mult() expression@\%          4
@\   @BNFor()@\expression || expression@\%               3
@\   @BNFor()@\expression + expression@\%               3
@\   @BNFor()@\expression @MinusSign() expression@\%               3
@\   @BNFor()@\expression < expression@\%                    2
@\   @BNFor()@\expression <= expression@\%                    2
@\   @BNFor()@\expression = expression@\%                    2
@\   @BNFor()@\expression >= expression@\%                    2
@\   @BNFor()@\expression > expression@\%                    2
@\   @BNFor()@\expression ~< expression@\%                    2
@\   @BNFor()@\expression ~<= expression@\%                    2
@\   @BNFor()@\expression ~= expression@\%                    2
@\   @BNFor()@\expression ~>= expression@\%                    2
@\   @BNFor()@\expression ~> expression@\%                    2
@\   @BNFor()@\expression & expression@\%                         1
@\   @BNFor()@\expression @b(cand) expression@\%                         1
@\   @BNFor()@\expression | expression@\%                              0
@\   @BNFor()@\expression @b(cor) expression@\%                              0

primary@\@BNFequals()@\entity
@\   @BNFor()@\call
@\   @BNFor()@\primary @big(.) name
@\   @BNFor()@\primary [ expression ]

call@\@BNFequals()@\primary ( @BNFlbkt() expression , @BNFdots() @BNFrbkt() )

@NewPage()

entity@\@BNFequals()@\@b(nil) 
@\   @BNFor()@\@b(true) 
@\   @BNFor()@\@b(false)
@\   @BNFor()@\int@us()literal 
@\   @BNFor()@\real@us()literal 
@\   @BNFor()@\char@us()literal 
@\   @BNFor()@\string@us()literal
@\   @BNFor()@\@b(self)
@\   @BNFor()@\reference
@\   @BNFor()@\entity @big(.) name
@\   @BNFor()@\entity [ expression ]
@\   @BNFor()@\@b(bind) entity ( @BNFlbkt() bind@us()arg , @BNFdots() @BNFrbkt() )
@\   @BNFor()@\type@us()spec $ { field , @BNFdots() }
@\   @BNFor()@\type@us()spec $ [ @BNFlbkt() expression : @BNFrbkt() @BNFlbkt() expression , @BNFdots() @BNFrbkt() ]
@\   @BNFor()@\type@us()spec $ name @BNFlbkt() [ actual@us<>parm , @BNFdots() ] @BNFrbkt()
@\   @BNFor()@\@b(up) ( expression )
@\   @BNFor()@\@b(down) ( expression )

field@\@BNFequals()@\name , @BNFdots() : expression

bind@us()arg@\@BNFequals()@\@mult()
@\   @BNFor()@\expression
@end(SyntaxDisplay)

@NewPage()

@i(Comment):
@index(comment)
@IndexEntry(Key=" %", Entry="%", Number)
a sequence of characters that begins with a percent sign (%),
ends with a newline character,
and contains only printing ASCII characters and horizontal tabs in between.

@i(Separator):
@index(separator)@index(token)
a blank character
(space, vertical tab, horizontal tab, carriage return, newline, form feed)
or a comment.
Zero or more separators may appear between any two tokens,
except that at least one separator is required between any two adjacent
non-self-terminating tokens:
reserved words,
identifiers,
integer literals,
and real literals.

@i(Reserved word):
@index(reserved word)
one of the identifiers appearing in @b[bold] face in the syntax.
Upper and lower case letters are not distinguished in reserved words.

@i(Name), @i(idn):
@index(name)@index(idn)
a sequence of
letters,
digits,
and underscores that begins with a letter or underscore,
and that is not a reserved word.
Upper and lower case letters are not distinguished in names and idns.

@i(Int@us<>literal):
@IndexSecondary(Primary="literal", Secondary="int")
a sequence of one or more decimal digits (0-9) or a backslash (\) followed by
any number of octal digits (0-7) or a backslash and a sharp sign (\#)
followed by any number of hexadecimal digits (0-9, A-F in upper or lower case).

@i(Real@us<>literal):
@IndexSecondary(Primary="literal", Secondary="real")
a mantissa with an (optional) exponent.
A mantissa is either a sequence of one or more decimal digits,
or two sequences (one of which may be empty) joined by a period.
The mantissa must contain at least one digit.
An exponent is 'E' or 'e',
optionally followed by '+' or '-',
followed by one or more decimal digits.
An exponent is required if the mantissa does not contain a period.

@i(Char@us<>literal):
@IndexSecondary(Primary="literal", Secondary="char")
a character representation other than single quote, enclosed in single quotes.
A character representation is either a printing ASCII character
(octal value 40 through 176) other than backslash,
or an escape sequence consisting of a backslash (\) followed one to three
printing characters
as shown in Table @ref(fig-character-escapes)
or Table @ref(tab-char-escapes) below.

@i(String@us<>literal):
@IndexSecondary(Primary="literal", Secondary="string")
a sequence of zero or more character representations
other than double quote, enclosed in double quotes.

Table @ref(tab-char-escapes)
shows most of the character literals supported by Argus,
@IndexSecondary(Primary="char", Secondary="escapes")
except for the higher numbered octal escape sequences.
For each character, the corresponding octal literal, hexadecimal literal,
and normal literal(s) are shown.
Upper or lower case letters may be used in escape sequences
of the form \#**, \^*, \!*, \b, \t, \n, \v, \p, and \r.
Note that an implementation need not support 256 characters, in which
case only a subset of the literals listed will be legal.

@NewPage()

@begin(Table, Need 27 lines)
@Caption(Character Escape Sequences)
@tag(tab-char-escapes)
@bar()
@end(Table)
@begin[Display, BlankLines Hinge]
@begin(small)
@TabClear()
@TabDivide(4)
'\000' '\#00' '\^@@'@\'\100' '\#40' '@@'@\'\200' '\#80' '\!@@'@\'\300' '\#C0' '\&@@'
'\001' '\#01' '\^A'@\'\101' '\#41' 'A'@\'\201' '\#81' '\!A'@\'\301' '\#C1' '\&A'
'\002' '\#02' '\^B'@\'\102' '\#42' 'B'@\'\202' '\#82' '\!B'@\'\302' '\#C2' '\&B'
'\003' '\#03' '\^C'@\'\103' '\#43' 'C'@\'\203' '\#83' '\!C'@\'\303' '\#C3' '\&C'
'\004' '\#04' '\^D'@\'\104' '\#44' 'D'@\'\204' '\#84' '\!D'@\'\304' '\#C4' '\&D'
'\005' '\#05' '\^E'@\'\105' '\#45' 'E'@\'\205' '\#85' '\!E'@\'\305' '\#C5' '\&E'
'\006' '\#06' '\^F'@\'\106' '\#46' 'F'@\'\206' '\#86' '\!F'@\'\306' '\#C6' '\&F'
'\007' '\#07' '\^G'@\'\107' '\#47' 'G'@\'\207' '\#87' '\!G'@\'\307' '\#C7' '\&G'

'\010' '\#08' '\^H' '\b'@\'\110' '\#48' 'H'@\'\210' '\#88' '\!H'@\'\310' '\#C8' '\&H'
'\011' '\#09' '\^I' '\t'@\'\111' '\#49' 'I'@\'\211' '\#89' '\!I'@\'\311' '\#C9' '\&I'
'\012' '\#0A' '\^J' '\n'@\'\112' '\#4A' 'J'@\'\212' '\#8A' '\!J'@\'\312' '\#CA' '\&J'
'\013' '\#0B' '\^K' '\v'@\'\113' '\#4B' 'K'@\'\213' '\#8B' '\!K'@\'\313' '\#CB' '\&K'
'\014' '\#0C' '\^L' '\p'@\'\114' '\#4C' 'L'@\'\214' '\#8C' '\!L'@\'\314' '\#CC' '\&L'
'\015' '\#0D' '\^M' '\r'@\'\115' '\#4D' 'M'@\'\215' '\#8D' '\!M'@\'\315' '\#CD' '\&M'
'\016' '\#0E' '\^N'@\'\116' '\#4E' 'N'@\'\216' '\#8E' '\!N'@\'\316' '\#CE' '\&N'
'\017' '\#0F' '\^O'@\'\117' '\#4F' 'O'@\'\217' '\#8F' '\!O'@\'\317' '\#CF' '\&O'

'\020' '\#10' '\^P'@\'\120' '\#50' 'P'@\'\220' '\#90' '\!P'@\'\320' '\#D0' '\&P'
'\021' '\#11' '\^Q'@\'\121' '\#51' 'Q'@\'\221' '\#91' '\!Q'@\'\321' '\#D1' '\&Q'
'\022' '\#12' '\^R'@\'\122' '\#52' 'R'@\'\222' '\#92' '\!R'@\'\322' '\#D2' '\&R'
'\023' '\#13' '\^S'@\'\123' '\#53' 'S'@\'\223' '\#93' '\!S'@\'\323' '\#D3' '\&S'
'\024' '\#14' '\^T'@\'\124' '\#54' 'T'@\'\224' '\#94' '\!T'@\'\324' '\#D4' '\&T'
'\025' '\#15' '\^U'@\'\125' '\#55' 'U'@\'\225' '\#95' '\!U'@\'\325' '\#D5' '\&U'
'\026' '\#16' '\^V'@\'\126' '\#56' 'V'@\'\226' '\#96' '\!V'@\'\326' '\#D6' '\&V'
'\027' '\#17' '\^W'@\'\127' '\#57' 'W'@\'\227' '\#97' '\!W'@\'\327' '\#D7' '\&W'

'\030' '\#18' '\^X'@\'\130' '\#58' 'X'@\'\230' '\#98' '\!X'@\'\330' '\#D8' '\&X'
'\031' '\#19' '\^Y'@\'\131' '\#59' 'Y'@\'\231' '\#99' '\!Y'@\'\331' '\#D9' '\&Y'
'\032' '\#1A' '\^Z'@\'\132' '\#5A' 'Z'@\'\232' '\#9A' '\!Z'@\'\332' '\#DA' '\&Z'
'\033' '\#1B' '\^['@\'\133' '\#5B' '['@\'\233' '\#9B' '\!['@\'\333' '\#DB' '\&['
'\034' '\#1C' '\^\'@\'\134' '\#5C' '\\'@\'\234' '\#9C' '\!\'@\'\334' '\#DC' '\&\'
'\035' '\#1D' '\^]'@\'\135' '\#5D' ']'@\'\235' '\#9D' '\!]'@\'\335' '\#DD' '\&]'
'\036' '\#1E' '\^^'@\'\136' '\#5E' '^'@\'\236' '\#9E' '\!^'@\'\336' '\#DE' '\&^'
'\037' '\#1F' '\^@us<>'@\'\137' '\#5F' '@us<>'@\'\237' '\#9F' '\!@us<>'@\'\337' '\#DF' '\&@us<>'

'\040' '\#20' ' '@\'\140' '\#60' '`'@\'\240' '\#A0' '\& '@\'\340' '\#E0' '\&`'
'\041' '\#21' '!'@\'\141' '\#61' 'a'@\'\241' '\#A1' '\&!'@\'\341' '\#E1' '\&a'
'\042' '\#22' '"' '\"'@\'\142' '\#62' 'b'@\'\242' '\#A2' '\&"'@\'\342' '\#E2' '\&b'
'\043' '\#23' '#'@\'\143' '\#63' 'c'@\'\243' '\#A3' '\&#'@\'\343' '\#E3' '\&c'
'\044' '\#24' '$'@\'\144' '\#64' 'd'@\'\244' '\#A4' '\&$'@\'\344' '\#E4' '\&d'
'\045' '\#25' '%'@\'\145' '\#65' 'e'@\'\245' '\#A5' '\&%'@\'\345' '\#E5' '\&e'
'\046' '\#26' '&'@\'\146' '\#66' 'f'@\'\246' '\#A6' '\&&'@\'\346' '\#E6' '\&f'
'\047' '\#27' '\''@\'\147' '\#67' 'g'@\'\247' '\#A7' '\&''@\'\347' '\#E7' '\&g'

'\050' '\#28' '('@\'\150' '\#68' 'h'@\'\250' '\#A8' '\&('@\'\350' '\#E8' '\&h'
'\051' '\#29' ')'@\'\151' '\#69' 'i'@\'\251' '\#A9' '\&)'@\'\351' '\#E9' '\&i'
'\052' '\#2A' '*'@\'\152' '\#6A' 'j'@\'\252' '\#AA' '\&*'@\'\352' '\#EA' '\&j'
'\053' '\#2B' '+'@\'\153' '\#6B' 'k'@\'\253' '\#AB' '\&+'@\'\353' '\#EB' '\&k'
'\054' '\#2C' ','@\'\154' '\#6C' 'l'@\'\254' '\#AC' '\&,'@\'\354' '\#EC' '\&l'
'\055' '\#2D' '-'@\'\155' '\#6D' 'm'@\'\255' '\#AD' '\&-'@\'\355' '\#ED' '\&m'
'\056' '\#2E' '.'@\'\156' '\#6E' 'n'@\'\256' '\#AE' '\&.'@\'\356' '\#EE' '\&n'
'\057' '\#2F' '/'@\'\157' '\#6F' 'o'@\'\257' '\#AF' '\&/'@\'\357' '\#EF' '\&o'

@NewPage()

'\060' '\#30' '0'@\'\160' '\#70' 'p'@\'\260' '\#B0' '\&0'@\'\360' '\#F0' '\&p'
'\061' '\#31' '1'@\'\161' '\#71' 'q'@\'\261' '\#B1' '\&1'@\'\361' '\#F1' '\&q'
'\062' '\#32' '2'@\'\162' '\#72' 'r'@\'\262' '\#B2' '\&2'@\'\362' '\#F2' '\&r'
'\063' '\#33' '3'@\'\163' '\#73' 's'@\'\263' '\#B3' '\&3'@\'\363' '\#F3' '\&s'
'\064' '\#34' '4'@\'\164' '\#74' 't'@\'\264' '\#B4' '\&4'@\'\364' '\#F4' '\&t'
'\065' '\#35' '5'@\'\165' '\#75' 'u'@\'\265' '\#B5' '\&5'@\'\365' '\#F5' '\&u'
'\066' '\#36' '6'@\'\166' '\#76' 'v'@\'\266' '\#B6' '\&6'@\'\366' '\#F6' '\&v'
'\067' '\#37' '7'@\'\167' '\#77' 'w'@\'\267' '\#B7' '\&7'@\'\367' '\#F7' '\&w'

'\070' '\#38' '8'@\'\170' '\#78' 'x'@\'\270' '\#B8' '\&8'@\'\370' '\#F8' '\&x'
'\071' '\#39' '9'@\'\171' '\#79' 'y'@\'\271' '\#B9' '\&9'@\'\371' '\#F9' '\&y'
'\072' '\#3A' ':'@\'\172' '\#7A' 'z'@\'\272' '\#BA' '\&:'@\'\372' '\#FA' '\&z'
'\073' '\#3B' ';'@\'\173' '\#7B' '{'@\'\273' '\#BB' '\&;'@\'\373' '\#FB' '\&{'
'\074' '\#3C' '<'@\'\174' '\#7C' '|'@\'\274' '\#BC' '\&<'@\'\374' '\#FC' '\&|'
'\075' '\#3D' '='@\'\175' '\#7D' '}'@\'\275' '\#BD' '\&='@\'\375' '\#FD' '\&}'
'\076' '\#3E' '>'@\'\176' '\#7E' '~'@\'\276' '\#BE' '\&>'@\'\376' '\#FE' '\&~'
'\077' '\#3F' '?'@\'\177' '\#7F' '\^?'@\'\277' '\#BF' '\&?'@\'\377' '\#FF' '\!?'
@end(small)
@bar()
@end[Display]
