@Device(PostScript)
@Make(Manual)
@Style[FontFamily=Helvetica, Size=10, Spacing=1.5, WidowAction=Force]
@LibraryFile(MultiLevelIndex)
@Modify(IndexEnv, Columns 2, Boxed)
@LibraryFile(Symbols)				@Comment{Ignore the Warning}
@PageHeading[Odd, Left "@Value(SectionNumber) @Value(SectionTitle)",
	Center "",
	Right "@Value(Page)"]
@PageHeading[Even, Left "@Value<Page>",
	Center "",
	Right "@Title(Chapter)"]
@Comment{ An underscore (sigh)}
@TextForm[UnderScore = "@ux[@w[  ]]"]
@Equate[us = underscore]
@Modify[Figure, Group, Break Around]
@Define[Small, Font SmallBodyFont, FaceCode R, Size 9]
@Comment{ Synonyms for title fonts }
@Define[Big, Font HeadingFont, FaceCode R, Size 14]
@Define[Huge, Font TitleFont, FaceCode R, Size 25]	@Comment{For the Title}
@Comment{ BNF Meta Symbols }
@TextForm<BNFequals={@big[::=]}>
@TextForm<BNFor={@big[|]}>
@TextForm<BNFdots={@big[...]}>
@TextForm<BNFlcurly="@big[{]">
@TextForm<BNFrcurly="@big[}]">
@TextForm<BNFlbkt="@big{[}">
@TextForm<BNFrbkt="@big{]}">
@Comment{ Minus signs that look right.  On the Dover use ^V or an _ }
@Define(mfont,facecode a)
@TextForm<MinusSign="@mfont(-)">
@Comment{Environment for Displaying Syntax}
@Define(SyntaxDisplay=Display, Spacing=1.4 lines, BlankLines Hinge)
@Include(00-preface.mss)
@Include(01-overview.mss)
@Include(02-concepts.mss)
@Include(03-environment.mss)
@Include(04-notation.mss)
@Include(05-lexical.mss)
@Include(06-types.mss)
@Include(07-scopes.mss)
@Include(08-call.mss)
@Include(09-exprs.mss)
@Include(10-stmts.mss)
@Include(11-exceptions.mss)
@Include(12-modules.mss)
@Include(13-guardians.mss)
@Include(14-transmit.mss)
@Include(15-atomics.mss)
@Include(a1-syntax.mss)
@Include(a2-type-defs.mss)
@Include(a3-guidelines.mss)
@Include(a4-changes.mss)
@Comment{ @Include(a5-examples.mss) }
