@Begin(Description)
%@\
Comment, rest of the line is ignored.

? [ cmdname ... ]@\
Print list of commands, or information about the given commands.

ACTIONS@\
List all the actions and their status.

CONTINUE@\
Resume execution from within a nested listen loop.

CURRENT [ context [ process ]]@\
Display [change] the current context [and process].

CURRENT/LONG [ context [ process ]]@\
Display [change] the current context [and process], long format.

CURRENT/SHORT [ context [ process ]]@\
Display [change] the current context [and process], short format.

CURRENT/VARIABLES [ context [ process ]]@\
Display [change] the current context [and process], with variables.

DEBUG process@\
Debug and cause a trap to the given process.

DEFAULTS [ cmdname [ options ]]@\
Display the defaults for all commands [or the given] or change a default.

DEFINED@\
List all defined debugging session variables and their values.

DISPLAY [ command ]@\
Open a new display with given command (if any) and cause displays to display.

EVALUATE expression_or_assignment@\
Evaluate and print value of the expression, equate, or assignment statement.

EVALUATE/TIME expression_or_assignment@\
Evaluate, and print, and show the CPU time used.

FRAMES [ framelist ]@\
Show [given] stack frames.

FRAMES/LONG [ framelist ]@\
Show [given] stack frames in long format.

FRAMES/OWNS [ framelist ]@\
Show [given] stack frames with owns.

FRAMES/PROCESS process [ ; framelist ]@\
Show [given] stack frames in the given process.

FRAMES/SHORT [ framelist ]@\
Show [given] stack frames in short format.

FRAMES/VARIABLES [ framelist ]@\
Show [given] stack frames with variables.

HELP [ cmdname ... ]@\
Print help information, or information about the given commands.

LIST-TRACE context ...@\
List the tracings in effect for the given contexts.

LOADED module ...@\
List all loaded modules matching the given modules.

LOADED/CALLERS module ...@\
List all routines which call the given routines.

LOADED/DUS module ...@\
List all loaded modules matching the given modules and their DUs.

LOADED/ITERATORS module ...@\
List matching loaded iterators.

LOADED/PROCEDURES module ...@\
List matching loaded procedures.

LOADED/STUBS module ...@\
List all loaded stub modules.

LOADED/TYPES module ...@\
List matching loaded clusters.

PRINTING@\
Show the current printing settings.

PRINTING/FLAT@\
Make printing be all on a line.

PRINTING/NOFLAT@\
Allow printing over several lines with reasonable indentation.

PRINTING/NOWRAP@\
Set printing to not wrap-around at the ends of lines.

PRINTING/WRAP@\
Set printing to wrap-around at the ends of lines.

PRINTING-DEPTH integer@\
Set the object printing depth to the given integer.

PRINTING-WIDTH integer@\
Set the object printing width to the given integer.

PROCESSES@\
Lists all the processes and their status.

QUIT@\
Terminate the debugging session.

READ file@\
Read input from the given file.

RESTART@\
Throw out all processes and discard all nested listen loops.

RESTORE-TRACING@\
Restore tracing inhibited by the Q, Y, or T breakpoint commands.

RETRY [ frame [ process ]]@\
Retry the current [given] frame's invocation.

RETURN [ ( expression ... ) ] [ frame [ process ]]@\
Return from current [given] frame.

SCRIPT [ outfile [ infile ] ]@\
Show scripting in effect, or script output to outfile, input the infile.

SIGNAL name [ ( expression ... ) ] [ frame [ process ]]@\
Raise exception from current [given] frame.

SLOTS context ... [ ; slotlist ]@\
List [given] slots in the given contexts.

STEP process [ ; framelist ]@\
Starts single stepping the current [or specified] frame[s] of the given process.

TRACE context ... [ ; slotlist ]@\
Set breakpoints at entries, exits, and slots [from given slots] in contexts.

TRACE/AT context ... [ ; slotlist ]@\
Set breakpoints at the entries and exits of [slots in the] given contexts.

TRACE/CALLS context ... [ ; slotlist ]@\
Set breakpoints at the entry to each [given slot in the] given contexts.

TRACE/EXITS context ...[ ; slotlist ]@\
Set breakpoints at all exits from the [given slots in the] given contexts.

TRACE/RETURNS context ... [ ; slotlist ]@\
Set breakpoints at all returns from [the given slots in] the given contexts.

TRACE/SIGNALS context ... [ ; slotlist ]@\
Set breakpoints at all signals from [the given slots in] the given contexts.

TRACE/YIELDS context ... [ ; slotlist ]@\
Set breakpoints at all yields from [the given slots in] the given contexts.

TRACE-EXCEPTION name ... ; context ...@\
Set breakpoints at all signals of the given name in the given contexts.

TRACE-UNINITIALIZED context ...@\
Trace all uninitialized variable references in the given contexts.

UNDEFINE idn ...@\
Undefine the given debugger session variables (make them go away).

UNDISPLAY integer@\
Close the specified display.

UNSCRIPT@\
Turn all scripting off.

UNSTEP process [ ; framelist ]@\
Stops single stepping the current [or specified] frame[s] of the given process.

UNTRACE context ... [ ; slotlist ]@\
Turn off all "trace" tracing in the given contexts [at the given slots].

UNTRACE/AT context ... [ ; slotlist ]@\
Turn off entry and exit tracing for the given contexts [at the given slots].

UNTRACE/CALLS context ... [ ; slotlist ]@\
Turn off entry tracing for the given contexts [at the given slots].

UNTRACE/EXITS context ... [ ; slotlist ]@\
Turn off exits tracing for the given contexts [at the given slots].

UNTRACE/RETURNS context ... [ ; slotlist ]@\
Turn off returns tracing for the given contexts [at the given slots].

UNTRACE/SIGNALS context ... [ ; slotlist ]@\
Turn off signals tracing from the given contexts [at the given slots].

UNTRACE/YIELDS context ...[ ; slotlist ]@\
Turn off yields tracing from the given contexts [at the given slots].

UNTRACE-EXCEPTION name ... ; context ...@\
Turns off trace-exception tracing of the named signals from the given contexts.

UNTRACE-UNINITIALIZED context ...@\
Turn off uninitialized variable tracing in the given contexts.

WATCH context ... [ ; slotlist ]@\
Set watch breakpoints at entries, exits, and slots [from given slots] in contexts.

WATCH/AT context ... [ ; slotlist ]@\
Set watch breakpoints at the entries and exits of [slots in the] given contexts.

WATCH/CALLS context ... [ ; slotlist ]@\
Set watch breakpoints at the entry to each [given slot in the] given contexts.

WATCH/EXITS context ...[ ; slotlist ]@\
Set watch breakpoints at all exits from the [given slots in the] given contexts.

WATCH/RETURNS context ... [ ; slotlist ]@\
Set watch breakpoints at all returns from [the given slots in] the given contexts.

WATCH/SIGNALS context ... [ ; slotlist ]@\
Set watch breakpoints at all signals from [the given slots in] the given contexts.

WATCH/YIELDS context ... [ ; slotlist ]@\
Set watch breakpoints at all yields from [the given slots in] the given contexts.

WATCH-EXCEPTION name ...@\
Set watch breakpoints at all signals of the given name.

YIELD [ ( expression ... ) ] [ frame [ process ]]@\
Yield from current [given] frame.
@End(Description)
