	# /bin/sh
# mkcmdequ -- make argus equate file from scribe file of command descriptions.
#
# SYNOPSIS:  The file is assumed to have the following format:
#	@begin(description...)
#	cmd@\
#	description.
#
#	cmd2 args2@\
#	description2.
#	@end(description)
# Only one line for each description.
#
# The sed script puts each item in the hold space, to be printed
# when the next command is given by the end of file, so that the correct
# separator (,) or terminator (]) may be appended.
#
# AUTHOR:	Gary T. Leavens

sed -n -e '1d
2i\
% Copyright 1984 Barbara Liskov\
_cmds = equates\
\
% commands:  name, arguments, and 1 line description.\
cmd_struct = struct[name: name_list, args, desc: string, doit: cproc_t]\
\
% list of components of a command name (separated by slashes)\
name_list = sequence[string]\
\
% procedures in _db_cmd cluster have this type\
cproc_t = proctype(name_list, pstream, string, _dbg_env)\
\	    signals(quit, syntax(string, int))\
\
\
% commands for the debugger\
% NOTE: this list must be SORTED!\
commands = sequence[cmd_struct]$[

/\([^ @][^ @]*\) \(.*\)@\\$/{
	s//cmd_struct\$\{name: name_list$["\1"],\
\ args: "\2",\
\ doit: _db_cmd$_\1,/
	:pname
	s!\( doit: .*\)[/-]!\1_!
	t pname
	:nlist
	s!\( name_list\$\[".*\)/\(.*\],\n\)!\1","\2!
	t nlist
	s/\( doit: _db_cmd\$\)_%,/\1_COMMENT,/
	s/\( doit: _db_cmd\$\)_\?,/\1_QUESTION_MARK,/
	x
	s/\(..*\)/\1,/p
	n
	s/"/\\"/g
	s/\(.*\)/ desc: "\1"\}/
	H
}

/\([^ @][^ @]*\)@\\$/{
	s//cmd_struct\$\{name: name_list$["\1"],\
\ args: "",\
\ doit: _db_cmd$_\1,/
	:pname1
	s!\( doit: .*\)[/-]!\1_!
	t pname1
	:nlist1
	s!\( name_list\$\[".*\)/\(.*\],\n\)!\1","\2!
	t nlist1
	s/\( doit: _db_cmd\$\)_^\(.\),/\1_CONTROL_\2,/
	s/\( doit: _db_cmd\$\)_<\([^>]*\)>,/\1_\2,/
	s/\( doit: _db_cmd\$\)_%,/\1_COMMENT,/
	s/\( doit: _db_cmd\$\)_\?,/\1_QUESTION_MARK,/
	x
	s/\(..*\)/\1,/p
	n
	s/"/\\"/g
	s/\(.*\)/ desc: "\1"\}/
	H
}

${
	x
	s/\(..*\)/\1\
]/p
}

$i\
end _cmds

'
