/* Copyright    Barbara Liskov    1988 */

#include <sys/types.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <sys/socket.h>
#include <net/route.h>
#include <netinet/acp.h>
#include <nlist.h>
#include <stdio.h>

struct nlist nl[] = {
#define	N_ACPSTAT	0
	{ "_acpstat" },
	"",
};

struct acpstat stats;

main()
{
	int kmem;

	nlist("/vmunix", nl);
	if (nl[0].n_type == 0) {
		fprintf(stderr, "/vmunix: no namelist\n");
		exit(1);
	}
	kmem = open("/dev/kmem", 0);
	if (kmem < 0) {
		perror("/dev/kmem");
		exit(1);
	}

	lseek(kmem, nl[N_ACPSTAT].n_value, 0);
	read(kmem, &stats, sizeof (struct acpstat));
	printf("packets read: %10lu\n", stats.as_rpkts);
	printf("bytes read:   %10lu", stats.as_rbyts);
	if (stats.as_rpkts != 0)
	printf("    (%u/pkt)", stats.as_rbyts / stats.as_rpkts);
	printf("\n");
	printf("packets sent: %10lu\n", stats.as_spkts);
	printf("bytes sent:   %10lu", stats.as_sbyts);
	if (stats.as_spkts != 0)
	printf("    (%u/pkt)", stats.as_sbyts / stats.as_spkts);
	printf("\n");
	printf("bad headers:  %10lu\n", stats.as_badhdr);
	printf("bad cksums:   %10lu\n", stats.as_badsum);
	printf("bad lengths:  %10lu\n", stats.as_badlen);
	printf("bad gids:     %10lu\n", stats.as_badgid);
	printf("queue drops:  %10lu\n", stats.as_noroom);
}
