/*
 *
 * UNIX CLU/Argus Debugger
 *
 */


/* This file contains the definitions for objects.
 */


/* Macros and definitions for extracting reference type bits */

#define	reftype(obj)	(((obj) >> 30) & 0x3)

#define	POSINT		0		/* positive integer */
#define	OBJPTR		1		/* object pointer */
#define	NONREF		2		/* illegal - nonreference */
#define	NEGINT		3		/* negative integer */


/* Macros and definitions for object types */

#define	objtype(hdr)	(((hdr) >> 29) & 0x3)

#define	VEC		0		/* vec - record, struct, or sequence */
#define	BVEC		1		/* bvec - string */
#define	CELL		2		/* cell - oneof, variant, or any */
#define	ADV		3		/* array dope vector */


/* Macros for extracting info from object headers */

#define	veclen(vec)	((vec) & 0x3ffff)
#define	bveclen(bvec)	((bvec) & 0xffff)
#define	celltag(cell)	((cell) & 0x3fff)


/* Tabbing information */

#define	NSPLVL		4		/* number of spaces per nesting lvl */
#define	BVECFUDGE	25		/* bvec size multiplier factor */
