; Copyright    Barbara Liskov    1984, 1986

; this cluster is designed specifically for the guardian manager

jpsize	= pk_omid + 4

_job = cluster is init, spawn, sig, restart

wvec	buf	7
wvec	errcod	1
wvec	argbuf	12	; assumes no more than 10 arguments
wvec	envbuf	11	; assumes no more than 10 variables
wvec	msgbuf	jpsize

init = proc ()
	var	x
	x := _gid$value()
	movl	msgbuf,n1
	movl	bvecw,,jpsize,(n1)			; setup the packet
	movl	af_inet,pk_af(n1)
	movab	x,n2
	movb	(n2)+,pk_gid+3(n1)			; byte swap gid
	movb	(n2)+,pk_gid+2(n1)
	movb	(n2)+,pk_gid+1(n1)
	movb	(n2),pk_gid(n1)
	x := node$here()
	movl	msgbuf,n1
	movab	x,n2
	movb	(n2)+,pk_host+3(n1)			; byte swap host
	movb	(n2)+,pk_host+2(n1)
	movb	(n2)+,pk_host+1(n1)
	movb	(n2),pk_host(n1)
	clrl	pk_xgid(n1)
	movl	min_int+max_int,pk_mid(n1)		; hack mid
	movl	1,pk_seq(n1)
	mnegl	1,pk_scc(n1)				; hack
	movb	mt_request,pk_type(n1)
	movl	pp_id(pp),pk_dpid(n1)
	mnegl	1,pk_dcc(n1)
	movl	buf,xp
	movl	3,(xp)					; number of args
	movl	sig_chld,4(xp)
	addl	16,xp,8(xp)
	clrl	12(xp)
	movab	death,16(xp)				; address
	bicb	1,16(xp)
	movl	sig_mask,20(xp)
	movl	true,24(xp)
	chmk	sigvec					; set handler
	return
	halt
death:	halt						; hack entry mask!
	nop
	qloop
		movl	[],xp
		movq	w_nohang,n0
		bispsw	\#f				; how disgusting
		ifcc	chmk	wait			; wait
		then	tstl	n0			; no more?
			beql	next
			movl	msgbuf,n2
			movl	n0,pk_spid(n2)		; hack
			movw	n1,pk_kind(n2)		; hack
			_io$send(n2, jpsize - pk_mid + 4)
			continue
		end
		cmpl	n0,e_intr
		beql	this
	end
	ret
	end init

spawn = proc (fn: string, uid, gid: int, home: string, argv, envv: sequence[string])
				returns (int) signals (not_possible(string))
	movl	buf,xp
	clrl	(xp)					; number of args
	clrl	@errcod
	ifcs	chmk	vfork				; create fork
	then	jsb	erstr
		signal	not_possible(rr)
	end
	ifeql	tstl	n1				; where are we?
	then	movl	n0,rr
		ifeql	movl	@errcod,n0		; everything ok?
		then	return(rr)
		end
		jsb	erstr
		signal	not_possible(rr)
	end
	movl	2,(xp)
	movl	uid,4(xp)
	movl	uid,8(xp)
	chmk	setreuid				; set uid
	movl	gid,4(xp)
	movl	gid,8(xp)
	chmk	setregid				; set gid
	movl	1,(xp)
	addl	4,home,4(xp)
	chmk	chdir					; set directory
	clrl	(xp)
	chmk	getdtablesize
	movl	n0,n4
	movl	3,(xp)					; number of args
	movl	3,4(xp)					; file desc
	movl	f_setfd,8(xp)
	movl	true,12(xp)
	qloop
		chmk	fcntl
		aobleq	n4,4(xp),this			; up to max
	end
	addl	4,fn,4(xp)				; file
	movl	argbuf,n3
	movl	n3,8(xp)
	movl	4(xp),(n3)+
	movl	argv,n1
	ifneq	movl	(n1)+,n5			; get count
	then	qloop
			addl	4,(n1)+,(n3)+		; cons refs
			sobgtr	n5,this
		end
	end
	clrl	(n3)+
	movl	envbuf,n3
	movl	n3,12(xp)
	movl	envv,n1
	ifneq	movl	(n1)+,n5			; get count
	then	qloop
			addl	4,(n1)+,(n3)+		; cons refs
			sobgtr	n5,this
		end
	end
	clrl	(n3)+
	chmk	execve					; do it
	movl	n0,@errcod
	movl	[sig_term],xp
	chmk	exit_
	end spawn

sig = qproc (j, signum: int) signals (not_possible(string))
	movl	buf,xp
	movl	2,(xp)					; number of args
	movl	j,4(xp)					; pid
	movl	rr,8(xp)				; signal
	ifcc	chmk	kill				; signal it
	then	return
	end
	jsb	erstr
	signal	not_possible(rr)
	end sig

restart = qproc ()
	movl	buf,xp
	movl	3,(xp)					; number of args
	movl	sig_io,4(xp)
	addl	16,xp,8(xp)				; addr
	clrl	12(xp)
	movl	sig_ign,16(xp)				; disable
	clrq	20(xp)
	chmk	sigvec
	movl	sig_chld,4(xp)
	chmk	sigvec
	movl	sig_alrm,4(xp)
	chmk	sigvec
	clrl	(xp)
	chmk	getdtablesize
	movl	n0,n4
	movl	1,(xp)					; number of args
	movl	3,4(xp)					; file desc
	qloop
		chmk	close				; close file
		aobleq	n4,4(xp),this			; up to max
	end
	movl	environ,n1
	movl	3,(xp)					; number of args
	movl	(n1),n2
	movl	4(n1),4(xp)				; program
	addl	4,n1,8(xp)				; arguments
	moval	8(n1)[n2],12(xp)			; environ
	chmk	execve
	end restart

end _job
