
; Copyright    Barbara Liskov    1985

; summary of x11 modifications: (7/29/88) (DWC)
;	added get_bp, get_sp, get_lp to get data at byte, short word,
;		and long word offsets respectively
;	increased rsize by 2 longwords (8 bytes), increased ibuf by 2
;		longwords
;	modified x_buf$get to take an input parameter, that is the
;		longword offset to the placement of subsequent data
;	rewrote enq to support x11 events 8/30/88

; summary of modifications: (9/2/88, JHC)
;	changed rsize from 32 to 40.
;	changed x_err to reflect X11's implementation.
; 9/7/90 dwc allowed flush to work properly if only one element in obuf
;	compared bufptr to bufmin rather than obuf

bufsize = 2048

;rsize = 24
rsize = 32	; increased size for x11

x_reply = 0
;x_err = -1
x_err = 0	; changed.

rcode = 16
parms = 20

x_buf = cluster is init,
		   get, send_data, send_array, flush, receive, 
		   receive_data, receive_data2, receive_auth,
		   events, wait,
		   get_lp0, get_lp1, get_lp2, get_lp3,
		   get_sp0, get_sp1, get_sp2, get_sp3, get_sp4, get_sp5,
		   get_bp0, get_bp1, get_bp2, get_bp_new,
		   get_bp10, get_bp11, get_bp, get_lp, 
		   get_sp

;wvec	ev 11
wvec	ev 15		; must match size of event structure in xdefs.arg w/hdr
wvec	wbuf 4
wvec	pbuf 5
wvec	obuf 513
;wvec	ibuf 10
wvec	ibuf 12	; increased size for x11
wvec	sbuf 7
wvec	padbuf	1
wvec	save_cptr 1
wvec	smask	1
wvec	imask	1

own	bufptr: _obj := 0
own	bufmin: _obj := 0
own	bufmax: _obj := 0
own	reqcount: int := 0
own	temp:int := -3
own	temp1:int := -4
own	save1:int := 0
own	save_bvptr:int
own	evcnt:int := 0
own	padc:int := 0

init = proc (addr: _bytevec) signals (error(string))
	movl	pbuf,xp
	movl	3,(xp)
	movzwl	4(rr),4(xp)
	movq	sock_stream,8(xp)
	loop
		chmk	socket
		bcc	next		; === break out of loop?
		cmpl	n0,e_intr
		beql	next
		br	death
	end
	movl	n0,r1
	movl	r1,4(xp)
	addl	4,rr,8(xp)
	movzwl	(rr),12(xp)
	qloop
		chmk	connect
		bcc	next		; === break out of loop?
		cmpl	n0,e_intr
		beql    next
		movl	n0,n1
		movl	1,(xp)
		chmk	close
		movl	n1,n0
death:		jsb	erstr
		signal	error(rr)
	end
	movl	wbuf,n1
	movl	3,(n1)
	movl	r1,4(n1)
	movl	ibuf,n1			; Initialize input buffer (ibuf)
	movl	3,(n1)			; 3 parameters to read call
	movl	r1,4(n1)		; 1st is socket
	addl	rcode,n1,8(n1)		; 2nd points to data area
	movl	rsize,12(n1)		; 3rd is size of data area
	movl	pbuf,n1
	movl	3,(n1)
	movl	r1,4(n1)
	movl	fionreadl,,fionreadr,8(n1)
	addl	16,n1,12(n1)
	movl	sbuf,n1
	movl	5,(n1)
	rotl	r1,1,@smask
	addl	1,r1,4(n1)
	addl	24,n1,8(n1)
	clrl	12(n1)
	clrq	16(n1)
	_io$get_chan()
	movl	sbuf,n1
	ifgeq	cmpl	rr,4(n1)
	then	addl	1,rr,4(n1)
	end
	rotl	rr,1,@imask
	bisl	@imask,@smask
	clrl	reqcount
	subl	4,obuf,bufmin
	movl	bufmin,bufptr
	addl	bufmin,bufsize,bufmax
	movl	14,@ev
	end init

; added input parameter (offset) for x11
get = proc (off:int) returns (oreq, ereq)
	ashl	2,rr,r1		; convert offset from longword to bytes (*4)
	movl	bufptr,rr
	addl	r1,bufptr	; use offset, rather than rsize
	ifgtr	cmpl	bufptr,bufmax
	then	movl	wbuf,xp
		movl	obuf,8(xp)
		subl	bufmin,rr,12(xp)
		qloop
			chmk	write
			bcc	no_oops
			cmpl	n0,e_intr
			beql	no_oops
			br 	oops
no_oops:		addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		movl	bufmin,rr
		addl	r1,rr,bufptr 	; use offset, rather than rsize
	end
	incl	reqcount
	addl	2,rr,-(sp)
	return(*, rr)
oops:	jsb	erstr
	_unhandled(rr)
	end get

send_data = qproc (b: _bytevec, strt, z: int)
	movq	strt,r1
	movzwl	(r2),n1
	if	sobgeq	r1,next
	then
bnds:		_unhandled("unhandled exception: bounds")
	end
	iflss	cmpl	r1,n1
	then	tstl	rr
		bleq	check
		addl	r1,rr,n0
		cmpl	n0,n1
		bgtr	bnds
		addl	3,rr
		bicb	3,rr
		movl	bufptr,r3
		addl	rr,r3,r4
		ifleq	cmpl	r4,bufmax
		then	movc	rr,4(r2)[r1],4(r3)
			movl	r4,bufptr
			return
		end
		movl	wbuf,xp
		movl	obuf,8(xp)
		subl	bufmin,r3,12(xp)
		qloop
			chmk	write
			bcc	no_oops
			cmpl	n0,e_intr
			beql	no_oops
			br 	oops
no_oops:		addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		movl	bufmin,bufptr
		movab	4(r2)[r1],8(xp)
		movl	rr,12(xp)
		qloop
			chmk	write
			bcc	no_oops2
			cmpl	n0,e_intr
			beql	no_oops2
			br 	oops
no_oops2:		addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		return
	end
	bgtr	bnds
check:	tstl	rr
	bneq	bnds
	return
oops:	jsb	erstr
	_unhandled(rr)
	end send_data

send_array = qproc (a: array[char], strt, z: int)
	ifleq	tstl	rr
	then	ifeql
		then	return
		end
bnds:		_unhandled("unhandled exception: bounds")
	end
	movq	strt,r1
	subl	dv_low(r2),r1
	cmpl	r1,dv_size(r2)
	bgtru	bnds
	addl	rr,r1,n3
	cmpl	n3,dv_size(r2)
	bgtr	bnds
	moval	@dv_rel(r2)[r1],n3
	addl	3,rr
	bicb	3,rr
	movl	bufptr,r3
	addl	rr,r3,r4
	ifgtr	cmpl	r4,bufmax
	then	movl	wbuf,xp
		movl	obuf,8(xp)
		subl	bufmin,r3,12(xp)
		qloop
			chmk	write
			bcc	no_oops
			cmpl	n0,e_intr
			beql	no_oops
			br 	oops
no_oops:		addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		movl	bufmin,r3
	end
	addl	4,r3
	qloop
		cvtlb	(n3)+,(r3)+
		sobgtr	rr,this
	end
	subl	4,r3,bufptr
	return
oops:	jsb	erstr
	_unhandled(rr)
	end send_array

flush = qproc ()
	ifgtr	cmpl	bufptr,bufmin
	then	movl	wbuf,xp
		movl	obuf,8(xp)
		subl	bufmin,bufptr,12(xp)
		qloop
			chmk	write
			bcc	no_oops
			cmpl	n0,e_intr
			beql	no_oops
			br 	oops
no_oops:		addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		movl	bufmin,bufptr
	end
	return
oops:	jsb	erstr
	_unhandled(rr)
	end flush

receive = proc () signals (error(string))
	ifgtr	cmpl	bufptr,obuf
	then	movl	wbuf,xp
		movl	obuf,8(xp)
		subl	bufmin,bufptr,12(xp)
		qloop
			chmk	write
			bcc	no_oops1
			cmpl	n0,e_intr
			beql	no_oops1
			br 	oops
no_oops1:		addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		movl	bufmin,bufptr
	end
	loop
		movl	ibuf,xp
		chmk	read
		bcc	no_oops
		cmpl	n0,e_intr
		beql	no_oops
		br 	oops
no_oops:	cmpl	n0,rsize
		bneq	bad
		movzbl	rcode(xp),temp
		ifneq	cmpl	temp,x_err
		then	x_buf$enq()
			continue
		end
		cvtbl	rcode+1(xp),-(sp)	; code
		cvtwl	rcode+2(xp),-(sp)	; seq. num
		pushl	rcode+4(xp)		; msg(?unused)
		cvtwl	rcode+8(xp),-(sp)	; minor opcode
		cvtbl	rcode+10(xp),rr		; major opcode
		ifeql	cmpw	rcode+2(xp),reqcount
		then	x_erstr(*, *, *, *, *)
			signal	error(rr)
		end
		x_erstr(*, *, *, *, *)
		x_error(rr)
	end
oops:	jsb	erstr
	_unhandled(rr)
bad:	_unhandled("incomplete message received")
	end receive

receive_auth = qproc (b: _bytevec)
;	x_print(true, "Starting x_buf$receive_auth")
	movl	wbuf,xp
	addl	4,rr,8(xp)
	movl	8,12(xp)
	qloop
		chmk	read
		bcc	no_oops2
		cmpl	n0,e_intr
		beql	no_oops2
		br 	oops
no_oops2:	addl	n0,8(xp)
		subl	n0,12(xp)
		bneq	this
	end
	movl	8(xp),n0
	movzwl	-2(n0),12(xp)
	ashl	2,12(xp),12(xp)
	qloop
		chmk	read
		bcc	no_oops1
		cmpl	n0,e_intr
		beql	no_oops1
		br 	oops
no_oops1:	addl	n0,8(xp)
		subl	n0,12(xp)
		bneq	this
	end
	ifneq	bicl	-4,(rr),n0
	then	subl	n0,4,12(xp)
		movl	padbuf,8(xp)
		qloop
			chmk	read
			bcc	no_oops
			cmpl	n0,e_intr
			beql	no_oops
			br 	oops
no_oops:		addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
	end
	return
oops:	jsb	erstr
	_unhandled(rr)
	end receive_auth

receive_data = proc (b: _bytevec)
    movl	rr,save_bvptr
    loop
	movl    save_bvptr,rr
	movl	wbuf,xp
	addl	4,rr,8(xp)	; buffer (skip past bytevec header)
	addl	4,rr,@save_cptr
;	movzwl	(rr),12(xp)	; count (length of bytevec)
	movl	32,12(xp)	; read 32 bytes
	qloop
		chmk	read
		bcc	no_oops2
		cmpl	n0,e_intr
		beql	no_oops2
		br 	oops
no_oops2:	addl	n0,8(xp)
		subl	n0,12(xp)
		bneq	this
	end
	movl	@save_cptr,xp
	movzbl  (xp),n0
	ifeql	cmpl n0,1
	then	
; 					if caller wanted 32 bytes return
		movl	wbuf,xp
		movl	save_bvptr,rr
		movzwl	(rr),n0
		subl	32,n0,12(xp)
		ifeql	tstl 12(xp)
		then 	return
		else
; 					else read rest of response
		qloop
			chmk	read
			bcc	no_oops1
			cmpl	n0,e_intr
			beql	no_oops1
			br 	oops
no_oops1:		addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		ifneq	bicl	-4,(rr),n0
		then	subl	n0,4,12(xp)
			movl	padbuf,8(xp)
			qloop
				chmk	read
				bcc	no_oops
				cmpl	n0,e_intr
				beql	no_oops
				br 	oops
no_oops:			addl	n0,8(xp)
				subl	n0,12(xp)
				bneq	this
			end
		end
		return
		end
	end
	ifeql	cmpl n0,0
	then	
		cvtbl	1(xp),-(sp)	; code
		cvtwl	2(xp),-(sp)	; seq. num
		pushl	0			; avoid bad values
		cvtwl	8(xp),-(sp)	; minor opcode
		cvtbl	10(xp),rr		; major opcode
		ifeql	cmpw	2(xp),reqcount
		then	x_erstr(*, *, *, *, *)
;			signal	error(rr)     ; restore this later
			x_error(rr)	      ; delete this later
		end
		x_erstr(*, *, *, *, *)
		x_error(rr)
		return
	end
	movl @save_cptr,rr
	subl rcode,rr
	x_buf$enq(rr)
   end
oops:	jsb	erstr
	_unhandled(rr)
	end receive_data

receive_data2 = proc (b: _bytevec)
	movl	wbuf,xp
	addl	4,rr,8(xp)	; buffer (skip past bytevec header)
	movzwl	(rr),12(xp)	; count (length of bytevec)
	qloop
		chmk	read
		bcc	no_oops
		cmpl	n0,e_intr
		beql	no_oops
		br 	oops
no_oops1:	addl	n0,8(xp)
		subl	n0,12(xp)
		bneq	this
	end
	ifneq	bicl	-4,(rr),n0
	then	subl	n0,4,12(xp)
		movl	padbuf,8(xp)
		qloop
			chmk	read
			bcc	no_oops
			cmpl	n0,e_intr
			beql	no_oops
			br 	oops
no_oops:		addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
	end
	return
oops:	jsb	erstr
	_unhandled(rr)
	end receive_data2

events = proc (need: bool)
	var	cnt
	ifgtr	cmpl	bufptr,obuf
	then	movl	wbuf,xp
		movl	obuf,8(xp)
		subl	bufmin,bufptr,12(xp)
		qloop
			chmk	write
			bcc	no_oops1
			cmpl	n0,e_intr
			beql	no_oops1
			br 	oops
no_oops1:		addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		movl	bufmin,bufptr
	end
	loop
again:		movl	pbuf,xp
		chmk	ioctl
		bcs	oops
		ifeql	movl	16(xp),cnt
		then	movl	need,cnt
			beql	next
		end
		clrl	need
		qloop
			movl	ibuf,xp
			chmk	read
			bcc	no_oops
			cmpl	n0,e_intr
			beql	no_oops
			br 	oops
no_oops:		ifneq	cmpl	n0,rsize
			then	_unhandled("incomplete message received")
			end
			ifeql	cmpl	rcode(xp),x_err
			then	cvtbl	rcode+1(xp),-(sp)
				cvtwl	rcode+2(xp),-(sp)
				pushl	rcode+4(xp)
				cvtwl   rcode+8(xp),-(sp)
				cvtbl	rcode+10(xp),rr
				x_erstr(*, *, *, *, *)
				x_error(rr)
				br	again
			end
			x_buf$enq(0)
			subl	rsize,cnt
			bgtr	this
		end
	end
	return
oops:	jsb	erstr
	_unhandled(rr)
	end events

wait = proc () returns (bool)
	ifgtr	cmpl	bufptr,obuf
	then	movl	wbuf,xp
		movl	obuf,8(xp)
		subl	bufmin,bufptr,12(xp)
		qloop
			chmk	write
			bcc	no_oops
			cmpl	n0,e_intr
			beql	this
			br 	oops
no_oops:		addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		movl	bufmin,bufptr
	end
	loop
		movl	pp_msgs(pp),rr
		tstl	dv_size(rr)
		bneq	next
		movl	sbuf,xp
		qloop
			movl	@smask,24(xp)
			ifcs	chmk	select_
			then	ifeql	cmpl	n0,e_badf
				then	_unhandled("bad file number")
				end
			elfeql	bitl	@imask,24(xp)
			then	x_buf$events(true)
				return(true)
			end
			blbc	intswap,this
		end
		_process$interrupt()
	end
	return(false)
oops:	jsb	erstr
	_unhandled(rr)
	end wait

enq = proc ()
	ifeql	tstl	rr
	then    movl	ibuf,xp
	else	movl	rr,xp
	end
	movl	ev,rr
	movzbl	rcode(xp),4(rr)		; kind
	movzbl	rcode+1(xp),36(rr)		; value/detail/unused
	movzwl	rcode+2(xp),24(rr)		; sequence number
	ifeql	cmpl 4(rr),Expose
	then
		movl	parms+0(xp),28(rr) ; sub
		movl	parms+0(xp),40(rr) ; win
		movzwl	parms+4,44(rr)	; x
		movzwl	parms+6,52(rr)	; y
		movzwl	parms+8,48(rr)	; x0
		movzwl	parms+10,56(rr)	; y0
	end
	ifeql	cmpl 4(rr),GraphicsExpose
	then
		movl	parms+0(xp),28(rr) ; sub
		movl	parms+0(xp),40(rr) ; win
		movzwl	parms+4,44(rr)	; x
		movzwl	parms+6,52(rr)	; y
		movzwl	parms+8,48(rr)	; x0
		movzwl	parms+10,56(rr)	; y0
	end
	ifeql	cmpl 4(rr),ConfigureNotify
	then
		movl	parms+4(pp),28(rr)	; sub
		movl	parms+4(pp),40(rr)	; win
		movzwl	parms+10(pp),44(rr)	; x
		movzwl	parms+12(pp),52(rr)	; y
		movzwl	parms+14(pp),48(rr)	; x0
		movzwl	parms+16(pp),56(rr)	; y0
	end
	ifeql	cmpl 4(rr),VisibilityNotify
	then
		movl    parms+0(xp),28(rr)
		movzbl	parms+4(xp),12(rr)
	end
	ifeql	cmpl 4(rr),MapNotify
	then
		movl	parms+0(xp),40(rr)
		movl	parms+4(xp),28(rr)
	end
	ifeql	cmpl 4(rr),UnmapNotify
	then
		movl	parms+0(xp),40(rr)
		movl	parms+4(xp),28(rr)
	end
	ifeql	cmpl 4(rr),FocusIn
	then
		movzbl	FocusChange,4(rr)
	end
	ifeql	cmpl 4(rr),FocusOut
	then
		movzbl	FocusChange,4(rr)
	end
	ifeql	cmpl 4(rr),FocusChange
	then	
		movl	parms+0(xp),40(rr)
		movzbl	parms+4(xp),12(rr)
	end
	ifeql	cmpl 4(rr),MotionNotify
	then	br   stuffit
	end
	ifeql	cmpl 4(rr),ButtonPressed
	then	br   stuffit
	end
	ifeql	cmpl 4(rr),ButtonReleased
	then	br   stuffit
	end
	ifeql	cmpl 4(rr),EnterWindow
	then	br   stuffit
	end
	ifeql	cmpl 4(rr),LeaveWindow
	then	br   stuffit
	end
	ifeql	cmpl 4(rr),KeyPressed
	then	br   stuffit
	end
	ifneq	cmpl 4(rr),KeyReleased
	then	br   cont
	end
stuffit:
				     ; event's root goes to root &win
				     ; event's win goes to sub
				     ; event's sub is omitted
	clrl	32(rr)   	     ; time for now
;	movl	parms+0(xp),32(rr)   ; time (omitted at least temporarily card32)
	movl	parms+4(xp),16(rr)   ; root (window)
	movl	parms+4(xp),40(rr)   ; (event) window
	movl	parms+8(xp),28(rr)   ; sub (window)   
	movzwl	parms+16(xp),48(rr)  ; root x
	movzwl	parms+18(xp),56(rr)  ; root y
	movzwl	parms+20(xp),44(rr)  ; event x
	movzwl  parms+22(xp),52(rr)  ; event y
	movzwl	parms+24(xp),8(rr)   ; state of key/button mask
	movzbl	parms+26(xp),20(rr)  ; same
	movzbl	parms+27(xp),12(rr)  ; mode / unused
cont:
	ifeql	cmpl 4(rr),MotionNotify
	then
		movzwl  parms+24(xp), n0
		ifeql	cmpl 	n0,RightMask
		then
			movl	RightDownMotion,4(rr)
		elfeql	cmpl 	n0,MiddleMask
		then
			movl	MiddleDownMotion,4(rr)
		else
			movl	LeftDownMotion,4(rr)
		end
	end
	x_input$enq(rr)
	end enq

get_lp0 = qproc () returns (int)
	movl	ibuf,rr
	movl	parms+0(rr),rr
	return(rr)
	end get_lp0

get_lp1 = qproc () returns (int)
	movl	ibuf,rr
	movl	parms+4(rr),rr
	return(rr)
	end get_lp1

get_lp2 = qproc () returns (int)
	movl	ibuf,rr
	movl	parms+8(rr),rr
	return(rr)
	end get_lp2

get_lp3 = qproc () returns (int)
	movl	ibuf,rr
	movl	parms+12(rr),rr
	return(rr)
	end get_lp3

get_sp0 = qproc () returns (int)
	movl	ibuf,rr
	cvtwl	parms+0(rr),rr
	return(rr)
	end get_sp0

get_sp1 = qproc () returns (int)
	movl	ibuf,rr
	cvtwl	parms+2(rr),rr
	return(rr)
	end get_sp1

get_sp2 = qproc () returns (int)
	movl	ibuf,rr
	cvtwl	parms+4(rr),rr
	return(rr)
	end get_sp2

get_sp3 = qproc () returns (int)
	movl	ibuf,rr
	cvtwl	parms+6(rr),rr
	return(rr)
	end get_sp3

get_sp4 = qproc () returns (int)
	movl	ibuf,rr
	cvtwl	parms+8(rr),rr
	return(rr)
	end get_sp4

get_sp5 = qproc () returns (int)
	movl	ibuf,rr
	cvtwl	parms+10(rr),rr
	return(rr)
	end get_sp5

get_bp0 = qproc () returns (int)
	movl	ibuf,rr
	cvtbl	rcode(rr),rr
	return(rr)
	end get_bp0
	
get_bp1 = qproc () returns (int)
	movl	ibuf,rr
	cvtbl	rcode+1(rr),rr
	return(rr)
	end get_bp1
	
get_bp2 = qproc () returns (int)
	movl	ibuf,rr
	cvtbl	rcode+2(rr),rr
	return(rr)
	end get_bp2
	
get_bp_new = qproc (off:int) returns (int)
	addl	ibuf, rr
	cvtbl	rcode(rr),rr
	return(rr)
	end get_bp_new
	
get_bp10 = qproc () returns (int)
	movl	ibuf,rr
	cvtbl	parms+10(rr),rr
	return(rr)
	end get_bp10

get_bp11 = qproc () returns (int)
	movl	ibuf,rr
	cvtbl	parms+11(rr),rr
	return(rr)
	end get_bp11

get_bp = qproc(off:int) returns (int)
	addl	ibuf, rr
	cvtbl	parms(rr),rr
	return(rr)
	end get_bp

get_sp = qproc(off:int) returns (int)
	ashl	1,rr,rr			; convert offset to bytes(*2)
	addl	ibuf, rr
	cvtwl	parms(rr),rr
	return(rr)
	end get_sp

get_lp = qproc(off:int) returns (int)
	ashl	2,rr,rr			; convert offset to bytes(*4)
	addl	ibuf, rr
	movl	parms(rr),rr
	return(rr)
	end get_lp

end x_buf
