; Copyright    Barbara Liskov    1985

bufsize = 2048

rsize = 24

x_reply = 0
x_err = -1

rcode = 16
parms = 20

x_buf = cluster is init,
		   get, send_data, send_array, flush, receive, receive_data,
		   events, wait,
		   get_lp0, get_lp1, get_lp2, get_lp3,
		   get_sp0, get_sp1, get_sp2, get_sp3, get_sp4, get_sp5,
		   get_bp10, get_bp11

wvec	ev 11
wvec	wbuf 4
wvec	pbuf 5
wvec	obuf 513
wvec	ibuf 10
wvec	sbuf 7
wvec	padbuf	1
wvec	smask	1
wvec	imask	1

own	bufptr: _obj := 0
own	bufmin: _obj := 0
own	bufmax: _obj := 0
own	reqcount: int := 0

init = proc (addr: _bytevec) signals (error(string))
	movl	pbuf,xp
	movl	3,(xp)
	movzwl	4(rr),4(xp)
	movq	sock_stream,8(xp)
	chmk	socket
	bcs	death
	movl	n0,r1
	movl	r1,4(xp)
	addl	4,rr,8(xp)
	movzwl	(rr),12(xp)
	ifcs	chmk	connect
	then	movl	n0,n1
		movl	1,(xp)
		chmk	close
		movl	n1,n0
death:		jsb	erstr
		signal	error(rr)
	end
	movl	wbuf,n1
	movl	3,(n1)
	movl	r1,4(n1)
	movl	ibuf,n1
	movl	3,(n1)
	movl	r1,4(n1)
	addl	rcode,n1,8(n1)
	movl	rsize,12(n1)
	movl	pbuf,n1
	movl	3,(n1)
	movl	r1,4(n1)
	movl	fionreadl,,fionreadr,8(n1)
	addl	16,n1,12(n1)
	movl	sbuf,n1
	movl	5,(n1)
	rotl	r1,1,@smask
	addl	1,r1,4(n1)
	addl	24,n1,8(n1)
	clrl	12(n1)
	clrq	16(n1)
	_io$get_chan()
	movl	sbuf,n1
	ifgeq	cmpl	rr,4(n1)
	then	addl	1,rr,4(n1)
	end
	rotl	rr,1,@imask
	bisl	@imask,@smask
	clrl	reqcount
	subl	4,obuf,bufmin
	movl	bufmin,bufptr
	addl	bufmin,bufsize,bufmax
	movl	10,@ev
	end init

get = qproc () returns (oreq, ereq)
	movl	bufptr,rr
	addl	rsize,bufptr
	ifgtr	cmpl	bufptr,bufmax
	then	movl	wbuf,xp
		movl	obuf,8(xp)
		subl	bufmin,rr,12(xp)
		qloop
			chmk	write
			bcs	oops
			addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		movl	bufmin,rr
		addl	rsize,rr,bufptr
	end
	incl	reqcount
	addl	2,rr,-(sp)
	return(*, rr)
oops:	jsb	erstr
	_unhandled(rr)
	end get

send_data = qproc (b: _bytevec, strt, z: int)
	movq	strt,r1
	movzwl	(r2),n1
	if	sobgeq	r1,next
	then
bnds:		_unhandled("unhandled exception: bounds")
	end
	iflss	cmpl	r1,n1
	then	tstl	rr
		bleq	check
		addl	r1,rr,n0
		cmpl	n0,n1
		bgtr	bnds
		addl	3,rr
		bicb	3,rr
		movl	bufptr,r3
		addl	rr,r3,r4
		ifleq	cmpl	r4,bufmax
		then	movc	rr,4(r2)[r1],4(r3)
			movl	r4,bufptr
			return
		end
		movl	wbuf,xp
		movl	obuf,8(xp)
		subl	bufmin,r3,12(xp)
		qloop
			chmk	write
			bcs	oops
			addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		movl	bufmin,bufptr
		movab	4(r2)[r1],8(xp)
		movl	rr,12(xp)
		qloop
			chmk	write
			bcs	oops
			addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		return
	end
	bgtr	bnds
check:	tstl	rr
	bneq	bnds
	return
oops:	jsb	erstr
	_unhandled(rr)
	end send_data

send_array = qproc (a: array[char], strt, z: int)
	ifleq	tstl	rr
	then	ifeql
		then	return
		end
bnds:		_unhandled("unhandled exception: bounds")
	end
	movq	strt,r1
	subl	dv_low(r2),r1
	cmpl	r1,dv_size(r2)
	bgtru	bnds
	addl	rr,r1,n3
	cmpl	n3,dv_size(r2)
	bgtr	bnds
	moval	@dv_rel(r2)[r1],n3
	addl	3,rr
	bicb	3,rr
	movl	bufptr,r3
	addl	rr,r3,r4
	ifgtr	cmpl	r4,bufmax
	then	movl	wbuf,xp
		movl	obuf,8(xp)
		subl	bufmin,r3,12(xp)
		qloop
			chmk	write
			bcs	oops
			addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		movl	bufmin,r3
	end
	addl	4,r3
	qloop
		cvtlb	(n3)+,(r3)+
		sobgtr	rr,this
	end
	subl	4,r3,bufptr
	return
oops:	jsb	erstr
	_unhandled(rr)
	end send_array

flush = qproc ()
	ifgtr	cmpl	bufptr,obuf
	then	movl	wbuf,xp
		movl	obuf,8(xp)
		subl	bufmin,bufptr,12(xp)
		qloop
			chmk	write
			bcs	oops
			addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		movl	bufmin,bufptr
	end
	return
oops:	jsb	erstr
	_unhandled(rr)
	end flush

receive = proc () signals (error(string))
	ifgtr	cmpl	bufptr,obuf
	then	movl	wbuf,xp
		movl	obuf,8(xp)
		subl	bufmin,bufptr,12(xp)
		qloop
			chmk	write
			bcs	oops
			addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		movl	bufmin,bufptr
	end
	loop
		movl	ibuf,xp
		chmk	read
		bcs	oops
		cmpl	n0,rsize
		bneq	bad
		ifeql	tstl	rcode(xp)
		then	return
		end
		ifneq	cmpl	rcode(xp),x_err
		then	x_buf$enq()
			continue
		end
		cvtbl	parms+4(xp),-(sp)
		pushl	parms+0(xp)
		cvtbl	parms+5(xp),-(sp)
		cvtbl	parms+6(xp),-(sp)
		movl	parms+8(xp),rr
		ifeql	cmpl	parms+0(xp),reqcount
		then	x_erstr(*, *, *, *, *)
			signal	error(rr)
		end
		x_erstr(*, *, *, *, *)
		x_error(rr)
	end
oops:	jsb	erstr
	_unhandled(rr)
bad:	_unhandled("incomplete message received")
	end receive

receive_data = qproc (b: _bytevec)
	movl	wbuf,xp
	addl	4,rr,8(xp)
	movzwl	(rr),12(xp)
	qloop
		chmk	read
		bcs	oops
		addl	n0,8(xp)
		subl	n0,12(xp)
		bneq	this
	end
	ifneq	bicl	-4,(rr),n0
	then	subl	n0,4,12(xp)
		movl	padbuf,8(xp)
		qloop
			chmk	read
			bcs	oops
			addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
	end
	return
oops:	jsb	erstr
	_unhandled(rr)
	end receive_data

events = proc (need: bool)
	var	cnt
	ifgtr	cmpl	bufptr,obuf
	then	movl	wbuf,xp
		movl	obuf,8(xp)
		subl	bufmin,bufptr,12(xp)
		qloop
			chmk	write
			bcs	oops
			addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		movl	bufmin,bufptr
	end
	loop
again:		movl	pbuf,xp
		chmk	ioctl
		bcs	oops
		ifeql	movl	16(xp),cnt
		then	movl	need,cnt
			beql	next
		end
		clrl	need
		qloop
			movl	ibuf,xp
			chmk	read
			bcs	oops
			ifneq	cmpl	n0,rsize
			then	_unhandled("incomplete message received")
			end
			ifeql	tstl	rcode(xp)
			then	_unhandled("protocol screwup")
			end
			ifeql	cmpl	rcode(xp),x_err
			then	cvtbl	parms+4(xp),-(sp)
				pushl	parms+0(xp)
				cvtbl	parms+5(xp),-(sp)
				cvtbl	parms+6(xp),-(sp)
				movl	parms+8(xp),rr
				x_erstr(*, *, *, *, *)
				x_error(rr)
				br	again
			end
			x_buf$enq()
			subl	rsize,cnt
			bgtr	this
		end
	end
	return
oops:	jsb	erstr
	_unhandled(rr)
	end events

wait = proc () returns (bool)
	ifgtr	cmpl	bufptr,obuf
	then	movl	wbuf,xp
		movl	obuf,8(xp)
		subl	bufmin,bufptr,12(xp)
		qloop
			chmk	write
			bcs	oops
			addl	n0,8(xp)
			subl	n0,12(xp)
			bneq	this
		end
		movl	bufmin,bufptr
	end
	loop
		movl	pp_msgs(pp),rr
		tstl	dv_size(rr)
		bneq	next
		movl	sbuf,xp
		qloop
			movl	@smask,24(xp)
			ifcs	chmk	select_
			then	ifeql	cmpl	n0,e_badf
				then	_unhandled("bad file number")
				end
			elfeql	bitl	@imask,24(xp)
			then	x_buf$events(true)
				return(true)
			end
			blbc	intswap,this
		end
		_process$interrupt()
	end
	return(false)
oops:	jsb	erstr
	_unhandled(rr)
	end wait

enq = proc ()
	movl	ibuf,xp
	movl	ev,rr
	movl	rcode(xp),4(rr)
	movl	parms+0(xp),24(rr)
	movl	parms+12(xp),12(rr)
	movzwl	parms+6(xp),20(rr)
	ifneq	bitw	ExposeWindow+ExposeRegion,rcode(xp)
	then	cvtwl	parms+8(xp),32(rr)
		cvtwl	parms+10(xp),40(rr)
		cvtwl	parms+16(xp),36(rr)
		cvtwl	parms+18(xp),28(rr)
	elfeql	bitw	UnmapWindow+FocusChange+ExposeCopy,rcode(xp)
	then	clrb	21(rr)
		movzwl	parms+4(xp),16(rr)
		movzwl	parms+6(xp),8(rr)
		clrb	8(rr)
		cvtwl	parms+8(xp),28(rr)
		cvtwl	parms+10(xp),36(rr)
		cvtwl	parms+16(xp),40(rr)
		cvtwl	parms+18(xp),32(rr)
	end
	x_input$enq(rr)
	end enq

get_lp0 = qproc () returns (int)
	movl	ibuf,rr
	movl	parms+0(rr),rr
	return(rr)
	end get_lp0

get_lp1 = qproc () returns (int)
	movl	ibuf,rr
	movl	parms+4(rr),rr
	return(rr)
	end get_lp1

get_lp2 = qproc () returns (int)
	movl	ibuf,rr
	movl	parms+8(rr),rr
	return(rr)
	end get_lp2

get_lp3 = qproc () returns (int)
	movl	ibuf,rr
	movl	parms+12(rr),rr
	return(rr)
	end get_lp3

get_sp0 = qproc () returns (int)
	movl	ibuf,rr
	cvtwl	parms+0(rr),rr
	return(rr)
	end get_sp0

get_sp1 = qproc () returns (int)
	movl	ibuf,rr
	cvtwl	parms+2(rr),rr
	return(rr)
	end get_sp1

get_sp2 = qproc () returns (int)
	movl	ibuf,rr
	cvtwl	parms+4(rr),rr
	return(rr)
	end get_sp2

get_sp3 = qproc () returns (int)
	movl	ibuf,rr
	cvtwl	parms+6(rr),rr
	return(rr)
	end get_sp3

get_sp4 = qproc () returns (int)
	movl	ibuf,rr
	cvtwl	parms+8(rr),rr
	return(rr)
	end get_sp4

get_sp5 = qproc () returns (int)
	movl	ibuf,rr
	cvtwl	parms+10(rr),rr
	return(rr)
	end get_sp5

get_bp10 = qproc () returns (int)
	movl	ibuf,rr
	cvtbl	parms+10(rr),rr
	return(rr)
	end get_bp10

get_bp11 = qproc () returns (int)
	movl	ibuf,rr
	cvtbl	parms+11(rr),rr
	return(rr)
	end get_bp11

end x_buf
