; Copyright    Barbara Liskov    1983

ac_oparse = qproc (a: array[char]) returns (int, bool)
				   signals (bad_format, overflow)
	movq	dv_size(rr),n1
	clrq	n3
	qloop
		subl	'0',(n2)+,n5
		cmpl	n5,7
		bgtru	bad
		ashq	3,n3,n3
		tstl	n4
		bneq	oflow
		addl	n5,n3
		sobgtr	n1,this
	end
	ifvc	addl	n3,n3,n0
	then	return(n3, false)
	end
	addl	\#8000,,0,n3,-(sp)
	return(*, true)
oflow:	signal	overflow
bad:	signal	bad_format
	end ac_oparse

ac_hparse = qproc (a: array[char]) returns (int, bool)
				   signals (bad_format, overflow)
	movq	dv_size(rr),n1
	clrq	n3
	qloop
		subl	'0',(n2)+,n5
		blss	bad
		ifgtr	cmpl	n5,9
		then	subl	'1',n5
			cmpl	n5,5
			bgtru	bad
			addl	10,n5
		end
		ashq	4,n3,n3
		tstl	n4
		bneq	oflow
		addl	n5,n3
		sobgtr	n1,this
	end
	ifvc	addl	n3,n3,n0
	then	return(n3, false)
	end
	addl	\#8000,,0,n3,-(sp)
	return(*, true)
oflow:	signal	overflow
bad:	signal	bad_format
	end ac_hparse

m_and = qproc (i1: int, m1: bool, i2: int, m2: bool) returns (int, bool)
	mcoml	i1,n1
	if	blbc	m1,next
	then	addl	\#8000,,0,n1
	end
	movl	i2,n2
	if	blbc	rr,next
	then	addl	\#8000,,0,n2
	end
	bicl	n1,n2,-(sp)
	ifvc	addl	(sp),(sp),n0
	then	return(*, false)
	end
	addl	\#8000,,0,(sp)
	return(*, true)
	end m_and

m_or = qproc (i1: int, m1: bool, i2: int, m2: bool) returns (int, bool)
	movl	i1,n1
	if	blbc	m1,next
	then	addl	\#8000,,0,n1
	end
	movl	i2,n2
	if	blbc	rr,next
	then	addl	\#8000,,0,n2
	end
	bisl	n1,n2,-(sp)
	ifvc	addl	(sp),(sp),n0
	then	return(*, false)
	end
	addl	\#8000,,0,(sp)
	return(*, true)
	end m_or

m_add = qproc (i1: int, m1: bool, i2: int, m2: bool) returns (int, bool)
	addl	i2,i1,n1
	ifneq	cmpl	m1,rr
	then	addl	\#8000,,0,n1
	end
	ifvc	addl	n1,n1,n0
	then	return(n1, false)
	end
	addl	\#8000,,0,n1,-(sp)
	return(*, true)
	end m_add

m_sub = qproc (i1: int, m1: bool, i2: int, m2: bool) returns (int, bool)
	subl	i2,i1,n1
	ifneq	cmpl	m1,rr
	then	addl	\#8000,,0,n1
	end
	ifvc	addl	n1,n1,n0
	then	return(n1, false)
	end
	addl	\#8000,,0,n1,-(sp)
	return(*, true)
	end m_sub

m_mul = qproc (i1: int, m1: bool, i2: int, m2: bool) returns (int, bool)
	movl	i1,n1
	if	blbc	m1,next
	then	addl	\#8000,,0,n1
	end
	movl	i2,n2
	if	blbc	rr,next
	then	addl	\#8000,,0,n2
	end
	mull	n1,n2,-(sp)
	ifvc	addl	(sp),(sp),n0
	then	return(*, false)
	end
	addl	\#8000,,0,(sp)
	return(*, true)
	end m_mul

m_div = qproc (i1: int, m1: bool, i2: int, m2: bool) returns (int, bool)
	movl	i1,n1
	if	blbc	m1,next
	then	addl	\#8000,,0,n1
	end
	movl	i2,n2
	if	blbc	rr,next
	then	addl	\#8000,,0,n2
	end
	divl	n2,n1,-(sp)
	ifvc	addl	(sp),(sp),n0
	then	return(*, false)
	end
	addl	\#8000,,0,(sp)
	return(*, true)
	end m_div

m_mod = qproc (i1: int, m1: bool, i2: int, m2: bool) returns (int, bool)
	movl	i1,n0
	if	blbc	m1,next
	then	addl	\#8000,,0,n0
	end
	clrl	n1
	movl	i2,n2
	if	blbc	rr,next
	then	addl	\#8000,,0,n2
	end
	ediv	n2,n0,n0,-(sp)
	ifvc	addl	(sp),(sp),n0
	then	return(*, false)
	end
	addl	\#8000,,0,(sp)
	return(*, true)
	end m_mod

m_shift = qproc (i1: int, m1: bool, i2: int, m2: bool) returns (int, bool)
	movl	i1,n1
	if	blbc	m1,next
	then	addl	\#8000,,0,n1
	end
	movl	i2,n2
	if	blbc	rr,next
	then	addl	\#8000,,0,n2
	end
	ashl	n2,n1,-(sp)
	ifvc	addl	(sp),(sp),n0
	then	return(*, false)
	end
	addl	\#8000,,0,(sp)
	return(*, true)
	end m_shift

m_pair = qproc (i1: int, m1: bool, i2: int, m2: bool) returns (int, bool)
	movl	i1,n1
	movl	i2,-(sp)
	movw	n1,2(sp)
	ifvc	addl	(sp),(sp),n0
	then	return(*, false)
	end
	addl	\#8000,,0,(sp)
	return(*, true)
	end m_pair

m_not = qproc (i: int, m: bool) returns (int, bool)
	mcoml	i,-(sp)
	return(*, rr)
	end m_not

m_minus = qproc (i: int, m: bool) returns (int, bool)
	mnegl	i,-(sp)
	return(*, rr)
	end m_minus
